
ModbusSlave_calcCRC:

;ModbusSlave.c,87 :: 		static uint calcCRC(uint uintLength) {
;ModbusSlave.c,90 :: 		movff    FARG_ModbusSlave_calcCRC_uintLength,R2  // byte count in R2
	MOVFF       FARG_ModbusSlave_calcCRC_uintLength+0, R2
;ModbusSlave.c,91 :: 		lfsr     0,ModbusSlave_aryBuffer                 // point to aryBuffer
	LFSR        0, ModbusSlave_aryBuffer+0
;ModbusSlave.c,92 :: 		setf     R0                // preset CRC
	SETF        R0, 1
;ModbusSlave.c,93 :: 		setf     R1
	SETF        R1, 1
;ModbusSlave.c,94 :: 		MBgetCRC1:
MBgetCRC1:
;ModbusSlave.c,95 :: 		movf     POSTINC0,W        // xor byte with CRClo
	MOVF        POSTINC0+0, 0, 1
;ModbusSlave.c,96 :: 		xorwf    R0,F
	XORWF       R0, 1, 1
;ModbusSlave.c,97 :: 		movlw    8                 // bit count in R3
	MOVLW       8
;ModbusSlave.c,98 :: 		movwf    R3
	MOVWF       R3, 1
;ModbusSlave.c,99 :: 		MBgetCRC2:
MBgetCRC2:
;ModbusSlave.c,100 :: 		bcf      STATUS,C
	BCF         STATUS+0, 0, 1
;ModbusSlave.c,101 :: 		rrcf     R1,F
	RRCF        R1, 1, 1
;ModbusSlave.c,102 :: 		rrcf     R0,F
	RRCF        R0, 1, 1
;ModbusSlave.c,103 :: 		bnc      $+10
	BNC         $+10
;ModbusSlave.c,104 :: 		movlw    0xA0
	MOVLW       160
;ModbusSlave.c,105 :: 		xorwf    R1,F
	XORWF       R1, 1, 1
;ModbusSlave.c,106 :: 		movlw    0x01
	MOVLW       1
;ModbusSlave.c,107 :: 		xorwf    R0,F
	XORWF       R0, 1, 1
;ModbusSlave.c,108 :: 		decfsz   R3,F
	DECFSZ      R3, 1, 1
;ModbusSlave.c,109 :: 		bra      MBgetCRC2
	BRA         MBgetCRC2
;ModbusSlave.c,110 :: 		decfsz   R2,F
	DECFSZ      R2, 1, 1
;ModbusSlave.c,111 :: 		bra      MBgetCRC1
	BRA         MBgetCRC1
;ModbusSlave.c,112 :: 		return
	RETURN      0
;ModbusSlave.c,114 :: 		return 0;
	CLRF        R0 
	CLRF        R1 
;ModbusSlave.c,115 :: 		}
L_end_calcCRC:
	RETURN      0
; end of ModbusSlave_calcCRC

ModbusSlave_coilState:

;ModbusSlave.c,127 :: 		static boolean coilState(uint uintAddress, boolean blnState) {
;ModbusSlave.c,129 :: 		if ( pWriteBlock == NULL ) {
	MOVLW       0
	XORWF       ModbusSlave_pWriteBlock+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_coilState200
	MOVLW       0
	XORWF       ModbusSlave_pWriteBlock+0, 0 
L_ModbusSlave_coilState200:
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_coilState3
;ModbusSlave.c,131 :: 		pWriteBlock = pCoils;
	MOVF        ModbusSlave_pCoils+0, 0 
	MOVWF       ModbusSlave_pWriteBlock+0 
	MOVF        ModbusSlave_pCoils+1, 0 
	MOVWF       ModbusSlave_pWriteBlock+1 
;ModbusSlave.c,132 :: 		while( pWriteBlock != NULL ) {
L_ModbusSlave_coilState4:
	MOVLW       0
	XORWF       ModbusSlave_pWriteBlock+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_coilState201
	MOVLW       0
	XORWF       ModbusSlave_pWriteBlock+0, 0 
L_ModbusSlave_coilState201:
	BTFSC       STATUS+0, 2 
	GOTO        L_ModbusSlave_coilState5
;ModbusSlave.c,133 :: 		asm nop; // removes use of FSR2
	NOP
;ModbusSlave.c,134 :: 		if ( uintAddress >= pWriteBlock->uintAddress
	MOVLW       1
	ADDWF       ModbusSlave_pWriteBlock+0, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      ModbusSlave_pWriteBlock+1, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	MOVWF       R1 
	MOVF        POSTINC2+0, 0 
	MOVWF       R2 
;ModbusSlave.c,136 :: 		pWriteBlock->uintTotal - 1)  ) {
	MOVF        R2, 0 
	SUBWF       FARG_ModbusSlave_coilState_uintAddress+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_coilState202
	MOVF        R1, 0 
	SUBWF       FARG_ModbusSlave_coilState_uintAddress+0, 0 
L_ModbusSlave_coilState202:
	BTFSS       STATUS+0, 0 
	GOTO        L_ModbusSlave_coilState8
;ModbusSlave.c,135 :: 		&& uintAddress <= (pWriteBlock->uintAddress +
	MOVLW       1
	ADDWF       ModbusSlave_pWriteBlock+0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      ModbusSlave_pWriteBlock+1, 0 
	MOVWF       FSR0H 
;ModbusSlave.c,136 :: 		pWriteBlock->uintTotal - 1)  ) {
	MOVLW       3
	ADDWF       ModbusSlave_pWriteBlock+0, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      ModbusSlave_pWriteBlock+1, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC2+0, 0 
	ADDWFC      POSTINC0+0, 0 
	MOVWF       R1 
	MOVLW       1
	SUBWF       R0, 0 
	MOVWF       R2 
	MOVLW       0
	SUBWFB      R1, 0 
	MOVWF       R3 
	MOVF        FARG_ModbusSlave_coilState_uintAddress+1, 0 
	SUBWF       R3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_coilState203
	MOVF        FARG_ModbusSlave_coilState_uintAddress+0, 0 
	SUBWF       R2, 0 
L_ModbusSlave_coilState203:
	BTFSS       STATUS+0, 0 
	GOTO        L_ModbusSlave_coilState8
L_ModbusSlave_coilState181:
;ModbusSlave.c,137 :: 		break;
	GOTO        L_ModbusSlave_coilState5
;ModbusSlave.c,138 :: 		}
L_ModbusSlave_coilState8:
;ModbusSlave.c,139 :: 		pWriteBlock = pWriteBlock->pNext;
	MOVLW       11
	ADDWF       ModbusSlave_pWriteBlock+0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      ModbusSlave_pWriteBlock+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       ModbusSlave_pWriteBlock+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       ModbusSlave_pWriteBlock+1 
;ModbusSlave.c,140 :: 		}
	GOTO        L_ModbusSlave_coilState4
L_ModbusSlave_coilState5:
;ModbusSlave.c,141 :: 		}
L_ModbusSlave_coilState3:
;ModbusSlave.c,142 :: 		if ( pWriteBlock != NULL ) {
	MOVLW       0
	XORWF       ModbusSlave_pWriteBlock+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_coilState204
	MOVLW       0
	XORWF       ModbusSlave_pWriteBlock+0, 0 
L_ModbusSlave_coilState204:
	BTFSC       STATUS+0, 2 
	GOTO        L_ModbusSlave_coilState9
;ModbusSlave.c,146 :: 		uintOffset = uintAddress - pWriteBlock->uintAddress;
	MOVLW       1
	ADDWF       ModbusSlave_pWriteBlock+0, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      ModbusSlave_pWriteBlock+1, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	SUBWF       FARG_ModbusSlave_coilState_uintAddress+0, 0 
	MOVWF       R3 
	MOVF        POSTINC2+0, 0 
	SUBWFB      FARG_ModbusSlave_coilState_uintAddress+1, 0 
	MOVWF       R4 
;ModbusSlave.c,147 :: 		bytIndex = uintOffset / 8;
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	MOVF        R0, 0 
	MOVWF       R5 
;ModbusSlave.c,148 :: 		bytBit = 1 << (uintOffset % 8);
	MOVLW       7
	ANDWF       R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	MOVLW       0
	ANDWF       R1, 1 
	MOVLW       1
	MOVWF       R6 
	MOVF        R0, 0 
L_ModbusSlave_coilState205:
	BZ          L_ModbusSlave_coilState206
	RLCF        R6, 1 
	BCF         R6, 0 
	ADDLW       255
	GOTO        L_ModbusSlave_coilState205
L_ModbusSlave_coilState206:
;ModbusSlave.c,150 :: 		if ( blnState == TRUE ) {
	MOVF        FARG_ModbusSlave_coilState_blnState+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_coilState10
;ModbusSlave.c,152 :: 		((byte*)pWriteBlock->paryData)[bytIndex] |= bytBit;
	MOVLW       5
	ADDWF       ModbusSlave_pWriteBlock+0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      ModbusSlave_pWriteBlock+1, 0 
	MOVWF       FSR0H 
	MOVF        R5, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       R1 
	MOVLW       0
	ADDWFC      POSTINC0+0, 0 
	MOVWF       R2 
	MOVFF       R1, FSR0
	MOVFF       R2, FSR0H
	MOVF        R6, 0 
	IORWF       POSTINC0+0, 0 
	MOVWF       R0 
	MOVFF       R1, FSR1
	MOVFF       R2, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,153 :: 		} else {
	GOTO        L_ModbusSlave_coilState11
L_ModbusSlave_coilState10:
;ModbusSlave.c,155 :: 		((byte*)pWriteBlock->paryData)[bytIndex] &= (0xff ^ bytBit);
	MOVLW       5
	ADDWF       ModbusSlave_pWriteBlock+0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      ModbusSlave_pWriteBlock+1, 0 
	MOVWF       FSR0H 
	MOVF        R5, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       R1 
	MOVLW       0
	ADDWFC      POSTINC0+0, 0 
	MOVWF       R2 
	MOVLW       255
	XORWF       R6, 0 
	MOVWF       R0 
	MOVFF       R1, FSR0
	MOVFF       R2, FSR0H
	MOVF        POSTINC0+0, 0 
	ANDWF       R0, 1 
	MOVFF       R1, FSR1
	MOVFF       R2, FSR1H
	MOVF        R0, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,156 :: 		}
L_ModbusSlave_coilState11:
;ModbusSlave.c,157 :: 		return TRUE;
	MOVLW       1
	MOVWF       R0 
	GOTO        L_end_coilState
;ModbusSlave.c,158 :: 		}
L_ModbusSlave_coilState9:
;ModbusSlave.c,159 :: 		return FALSE;
	CLRF        R0 
;ModbusSlave.c,160 :: 		}
L_end_coilState:
	RETURN      0
; end of ModbusSlave_coilState

ModbusSlave_packBits:

;ModbusSlave.c,175 :: 		uint uintStart, uint uintEnd) {
;ModbusSlave.c,178 :: 		uint uintBytes = 0;
	CLRF        ModbusSlave_packBits_uintBytes_L0+0 
	CLRF        ModbusSlave_packBits_uintBytes_L0+1 
;ModbusSlave.c,180 :: 		if ( eType == COILS ) {
	MOVF        FARG_ModbusSlave_packBits_eType+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits12
;ModbusSlave.c,181 :: 		pNode = pCoils;
	MOVF        ModbusSlave_pCoils+0, 0 
	MOVWF       R8 
	MOVF        ModbusSlave_pCoils+1, 0 
	MOVWF       R9 
;ModbusSlave.c,182 :: 		} else if( eType == STATUS_INPUTS ) {
	GOTO        L_ModbusSlave_packBits13
L_ModbusSlave_packBits12:
	MOVF        FARG_ModbusSlave_packBits_eType+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits14
;ModbusSlave.c,183 :: 		pNode = pStatusBits;
	MOVF        ModbusSlave_pStatusBits+0, 0 
	MOVWF       R8 
	MOVF        ModbusSlave_pStatusBits+1, 0 
	MOVWF       R9 
;ModbusSlave.c,184 :: 		} else {
	GOTO        L_ModbusSlave_packBits15
L_ModbusSlave_packBits14:
;ModbusSlave.c,185 :: 		return 0;
	CLRF        R0 
	CLRF        R1 
	GOTO        L_end_packBits
;ModbusSlave.c,186 :: 		}
L_ModbusSlave_packBits15:
L_ModbusSlave_packBits13:
;ModbusSlave.c,187 :: 		while( pNode != NULL ) {
L_ModbusSlave_packBits16:
	MOVLW       0
	XORWF       R9, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits208
	MOVLW       0
	XORWF       R8, 0 
L_ModbusSlave_packBits208:
	BTFSC       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits17
;ModbusSlave.c,188 :: 		asm nop; // removes use of FSR2
	NOP
;ModbusSlave.c,189 :: 		if ( uintStart >= pNode->uintAddress ) {
	MOVLW       1
	ADDWF       R8, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      R9, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	MOVWF       R1 
	MOVF        POSTINC2+0, 0 
	MOVWF       R2 
	MOVF        R2, 0 
	SUBWF       FARG_ModbusSlave_packBits_uintStart+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits209
	MOVF        R1, 0 
	SUBWF       FARG_ModbusSlave_packBits_uintStart+0, 0 
L_ModbusSlave_packBits209:
	BTFSS       STATUS+0, 0 
	GOTO        L_ModbusSlave_packBits18
;ModbusSlave.c,190 :: 		break;
	GOTO        L_ModbusSlave_packBits17
;ModbusSlave.c,191 :: 		}
L_ModbusSlave_packBits18:
;ModbusSlave.c,192 :: 		pNode = pNode->pNext;
	MOVLW       11
	ADDWF       R8, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R9, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R8 
	MOVF        POSTINC0+0, 0 
	MOVWF       R9 
;ModbusSlave.c,193 :: 		}
	GOTO        L_ModbusSlave_packBits16
L_ModbusSlave_packBits17:
;ModbusSlave.c,194 :: 		if ( pNode != NULL && uintEnd < pNode->uintAddress + pNode->uintTotal ) {
	MOVLW       0
	XORWF       R9, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits210
	MOVLW       0
	XORWF       R8, 0 
L_ModbusSlave_packBits210:
	BTFSC       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits21
	MOVLW       1
	ADDWF       R8, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      R9, 0 
	MOVWF       R1 
	MOVLW       3
	ADDWF       R8, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      R9, 0 
	MOVWF       FSR2H 
	MOVFF       R0, FSR0
	MOVFF       R1, FSR0H
	MOVF        POSTINC2+0, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        POSTINC2+0, 0 
	ADDWFC      POSTINC0+0, 0 
	MOVWF       R2 
	MOVF        R2, 0 
	SUBWF       FARG_ModbusSlave_packBits_uintEnd+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits211
	MOVF        R1, 0 
	SUBWF       FARG_ModbusSlave_packBits_uintEnd+0, 0 
L_ModbusSlave_packBits211:
	BTFSC       STATUS+0, 0 
	GOTO        L_ModbusSlave_packBits21
L_ModbusSlave_packBits182:
;ModbusSlave.c,198 :: 		uintOffset = uintStart - pNode->uintAddress;
	MOVLW       1
	ADDWF       R8, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      R9, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	SUBWF       FARG_ModbusSlave_packBits_uintStart+0, 0 
	MOVWF       R3 
	MOVF        POSTINC2+0, 0 
	SUBWFB      FARG_ModbusSlave_packBits_uintStart+1, 0 
	MOVWF       R4 
	MOVF        R3, 0 
	MOVWF       R5 
	MOVF        R4, 0 
	MOVWF       R6 
;ModbusSlave.c,200 :: 		bytIndex = uintOffset / 8;
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R1, 7 
	MOVF        R0, 0 
	MOVWF       R7 
;ModbusSlave.c,202 :: 		Hi(uintOffset) = 1 << (Lo(uintOffset) & 7);
	MOVLW       7
	ANDWF       R5, 0 
	MOVWF       R0 
	MOVLW       1
	MOVWF       R6 
	MOVF        R0, 0 
L_ModbusSlave_packBits212:
	BZ          L_ModbusSlave_packBits213
	RLCF        R6, 1 
	BCF         R6, 0 
	ADDLW       255
	GOTO        L_ModbusSlave_packBits212
L_ModbusSlave_packBits213:
;ModbusSlave.c,204 :: 		Lo(uintOffset) = 1;
	MOVLW       1
	MOVWF       R5 
;ModbusSlave.c,206 :: 		*pBuffer = 0;
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+0, FSR1
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+1, FSR1H
	CLRF        POSTINC1+0 
;ModbusSlave.c,207 :: 		while( uintStart <= uintEnd ) {
L_ModbusSlave_packBits22:
	MOVF        FARG_ModbusSlave_packBits_uintStart+1, 0 
	SUBWF       FARG_ModbusSlave_packBits_uintEnd+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits214
	MOVF        FARG_ModbusSlave_packBits_uintStart+0, 0 
	SUBWF       FARG_ModbusSlave_packBits_uintEnd+0, 0 
L_ModbusSlave_packBits214:
	BTFSS       STATUS+0, 0 
	GOTO        L_ModbusSlave_packBits23
;ModbusSlave.c,208 :: 		if ( Lo(uintOffset).B0 ) {
	BTFSS       R5, 0 
	GOTO        L_ModbusSlave_packBits24
;ModbusSlave.c,209 :: 		uintBytes++;
	INFSNZ      ModbusSlave_packBits_uintBytes_L0+0, 1 
	INCF        ModbusSlave_packBits_uintBytes_L0+1, 1 
;ModbusSlave.c,210 :: 		}
L_ModbusSlave_packBits24:
;ModbusSlave.c,212 :: 		if ( (((byte*)pNode->paryData)[bytIndex] & Hi(uintOffset)) ) {
	MOVLW       5
	ADDWF       R8, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R9, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R7, 0 
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        R6, 0 
	ANDWF       POSTINC0+0, 0 
	MOVWF       R0 
	BTFSC       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits25
;ModbusSlave.c,213 :: 		*pBuffer |= Lo(uintOffset);
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+0, FSR0
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+1, FSR0H
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+0, FSR1
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+1, FSR1H
	MOVF        R5, 0 
	IORWF       POSTINC0+0, 1 
;ModbusSlave.c,214 :: 		}
L_ModbusSlave_packBits25:
;ModbusSlave.c,215 :: 		Hi(uintOffset) <<= 1;
	MOVF        R6, 0 
	MOVWF       R1 
	RLCF        R1, 1 
	BCF         R1, 0 
	MOVF        R1, 0 
	MOVWF       R6 
;ModbusSlave.c,217 :: 		if ( Hi(uintOffset) == 0 ) {
	MOVF        R1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits26
;ModbusSlave.c,218 :: 		Hi(uintOffset) = 1;
	MOVLW       1
	MOVWF       R6 
;ModbusSlave.c,219 :: 		bytIndex++;
	INCF        R7, 1 
;ModbusSlave.c,220 :: 		}
L_ModbusSlave_packBits26:
;ModbusSlave.c,221 :: 		Lo(uintOffset) <<= 1;
	RLCF        R5, 1 
	BCF         R5, 0 
;ModbusSlave.c,223 :: 		if ( Lo(uintOffset) == 0 ) {
	MOVF        R5, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packBits27
;ModbusSlave.c,224 :: 		Lo(uintOffset) = 1;
	MOVLW       1
	MOVWF       R5 
;ModbusSlave.c,225 :: 		pBuffer++;
	INFSNZ      FARG_ModbusSlave_packBits_pBuffer+0, 1 
	INCF        FARG_ModbusSlave_packBits_pBuffer+1, 1 
;ModbusSlave.c,226 :: 		*pBuffer = 0;
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+0, FSR1
	MOVFF       FARG_ModbusSlave_packBits_pBuffer+1, FSR1H
	CLRF        POSTINC1+0 
;ModbusSlave.c,227 :: 		}
L_ModbusSlave_packBits27:
;ModbusSlave.c,229 :: 		uintStart++;
	INFSNZ      FARG_ModbusSlave_packBits_uintStart+0, 1 
	INCF        FARG_ModbusSlave_packBits_uintStart+1, 1 
;ModbusSlave.c,230 :: 		}
	GOTO        L_ModbusSlave_packBits22
L_ModbusSlave_packBits23:
;ModbusSlave.c,231 :: 		}
L_ModbusSlave_packBits21:
;ModbusSlave.c,232 :: 		return uintBytes;
	MOVF        ModbusSlave_packBits_uintBytes_L0+0, 0 
	MOVWF       R0 
	MOVF        ModbusSlave_packBits_uintBytes_L0+1, 0 
	MOVWF       R1 
;ModbusSlave.c,233 :: 		}
L_end_packBits:
	RETURN      0
; end of ModbusSlave_packBits

ModbusSlave_packRegisters:

;ModbusSlave.c,248 :: 		uint uintStart, uint uintEnd) {
;ModbusSlave.c,251 :: 		uint uintBytes = 0;
	CLRF        ModbusSlave_packRegisters_uintBytes_L0+0 
	CLRF        ModbusSlave_packRegisters_uintBytes_L0+1 
;ModbusSlave.c,253 :: 		if ( eType == HOLDING_REGISTERS ) {
	MOVF        FARG_ModbusSlave_packRegisters_eType+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters28
;ModbusSlave.c,254 :: 		pNode = pHoldingRegs;
	MOVF        ModbusSlave_pHoldingRegs+0, 0 
	MOVWF       R7 
	MOVF        ModbusSlave_pHoldingRegs+1, 0 
	MOVWF       R8 
;ModbusSlave.c,255 :: 		} else if( eType == INPUT_REGISTERS ) {
	GOTO        L_ModbusSlave_packRegisters29
L_ModbusSlave_packRegisters28:
	MOVF        FARG_ModbusSlave_packRegisters_eType+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters30
;ModbusSlave.c,256 :: 		pNode = pInputRegs;
	MOVF        ModbusSlave_pInputRegs+0, 0 
	MOVWF       R7 
	MOVF        ModbusSlave_pInputRegs+1, 0 
	MOVWF       R8 
;ModbusSlave.c,257 :: 		} else {
	GOTO        L_ModbusSlave_packRegisters31
L_ModbusSlave_packRegisters30:
;ModbusSlave.c,258 :: 		return 0;
	CLRF        R0 
	CLRF        R1 
	GOTO        L_end_packRegisters
;ModbusSlave.c,259 :: 		}
L_ModbusSlave_packRegisters31:
L_ModbusSlave_packRegisters29:
;ModbusSlave.c,260 :: 		while( pNode != NULL ) {
L_ModbusSlave_packRegisters32:
	MOVLW       0
	XORWF       R8, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters216
	MOVLW       0
	XORWF       R7, 0 
L_ModbusSlave_packRegisters216:
	BTFSC       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters33
;ModbusSlave.c,261 :: 		asm nop; // removes use of FSR2
	NOP
;ModbusSlave.c,262 :: 		if ( uintStart >= pNode->uintAddress ) {
	MOVLW       1
	ADDWF       R7, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      R8, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	MOVWF       R1 
	MOVF        POSTINC2+0, 0 
	MOVWF       R2 
	MOVF        R2, 0 
	SUBWF       FARG_ModbusSlave_packRegisters_uintStart+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters217
	MOVF        R1, 0 
	SUBWF       FARG_ModbusSlave_packRegisters_uintStart+0, 0 
L_ModbusSlave_packRegisters217:
	BTFSS       STATUS+0, 0 
	GOTO        L_ModbusSlave_packRegisters34
;ModbusSlave.c,263 :: 		break;
	GOTO        L_ModbusSlave_packRegisters33
;ModbusSlave.c,264 :: 		}
L_ModbusSlave_packRegisters34:
;ModbusSlave.c,265 :: 		pNode = pNode->pNext;
	MOVLW       11
	ADDWF       R7, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R8, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R7 
	MOVF        POSTINC0+0, 0 
	MOVWF       R8 
;ModbusSlave.c,266 :: 		}
	GOTO        L_ModbusSlave_packRegisters32
L_ModbusSlave_packRegisters33:
;ModbusSlave.c,267 :: 		if ( pNode != NULL && uintEnd < (pNode->uintAddress + pNode->uintTotal) ) {
	MOVLW       0
	XORWF       R8, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters218
	MOVLW       0
	XORWF       R7, 0 
L_ModbusSlave_packRegisters218:
	BTFSC       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters37
	MOVLW       1
	ADDWF       R7, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R8, 0 
	MOVWF       FSR0H 
	MOVLW       3
	ADDWF       R7, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      R8, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        POSTINC2+0, 0 
	ADDWFC      POSTINC0+0, 0 
	MOVWF       R2 
	MOVF        R2, 0 
	SUBWF       FARG_ModbusSlave_packRegisters_uintEnd+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters219
	MOVF        R1, 0 
	SUBWF       FARG_ModbusSlave_packRegisters_uintEnd+0, 0 
L_ModbusSlave_packRegisters219:
	BTFSC       STATUS+0, 0 
	GOTO        L_ModbusSlave_packRegisters37
L_ModbusSlave_packRegisters183:
;ModbusSlave.c,269 :: 		uintOffset = uintStart - pNode->uintAddress;
	MOVLW       1
	ADDWF       R7, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      R8, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	SUBWF       FARG_ModbusSlave_packRegisters_uintStart+0, 0 
	MOVWF       R5 
	MOVF        POSTINC2+0, 0 
	SUBWFB      FARG_ModbusSlave_packRegisters_uintStart+1, 0 
	MOVWF       R6 
;ModbusSlave.c,270 :: 		while( uintStart <= uintEnd ) {
L_ModbusSlave_packRegisters38:
	MOVF        FARG_ModbusSlave_packRegisters_uintStart+1, 0 
	SUBWF       FARG_ModbusSlave_packRegisters_uintEnd+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_packRegisters220
	MOVF        FARG_ModbusSlave_packRegisters_uintStart+0, 0 
	SUBWF       FARG_ModbusSlave_packRegisters_uintEnd+0, 0 
L_ModbusSlave_packRegisters220:
	BTFSS       STATUS+0, 0 
	GOTO        L_ModbusSlave_packRegisters39
;ModbusSlave.c,271 :: 		pBuffer[uintBytes++] = Hi(((uint*)pNode->paryData)[uintOffset]);
	MOVF        ModbusSlave_packRegisters_uintBytes_L0+0, 0 
	ADDWF       FARG_ModbusSlave_packRegisters_pBuffer+0, 0 
	MOVWF       FSR1 
	MOVF        ModbusSlave_packRegisters_uintBytes_L0+1, 0 
	ADDWFC      FARG_ModbusSlave_packRegisters_pBuffer+1, 0 
	MOVWF       FSR1H 
	MOVLW       5
	ADDWF       R7, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R8, 0 
	MOVWF       FSR0H 
	MOVF        R5, 0 
	MOVWF       R0 
	MOVF        R6, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        POSTINC0+0, 0 
	ADDWF       R0, 1 
	MOVF        POSTINC0+0, 0 
	ADDWFC      R1, 1 
	MOVLW       1
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
	INFSNZ      ModbusSlave_packRegisters_uintBytes_L0+0, 1 
	INCF        ModbusSlave_packRegisters_uintBytes_L0+1, 1 
;ModbusSlave.c,272 :: 		asm nop; // removes use of FSR2
	NOP
;ModbusSlave.c,273 :: 		pBuffer[uintBytes++] = Lo(((uint*)pNode->paryData)[uintOffset]);
	MOVF        ModbusSlave_packRegisters_uintBytes_L0+0, 0 
	ADDWF       FARG_ModbusSlave_packRegisters_pBuffer+0, 0 
	MOVWF       FSR1 
	MOVF        ModbusSlave_packRegisters_uintBytes_L0+1, 0 
	ADDWFC      FARG_ModbusSlave_packRegisters_pBuffer+1, 0 
	MOVWF       FSR1H 
	MOVLW       5
	ADDWF       R7, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R8, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R3 
	MOVF        POSTINC0+0, 0 
	MOVWF       R4 
	MOVF        R5, 0 
	MOVWF       R0 
	MOVF        R6, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	ADDWF       R3, 0 
	MOVWF       FSR0 
	MOVF        R1, 0 
	ADDWFC      R4, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
	INFSNZ      ModbusSlave_packRegisters_uintBytes_L0+0, 1 
	INCF        ModbusSlave_packRegisters_uintBytes_L0+1, 1 
;ModbusSlave.c,275 :: 		uintStart++;
	INFSNZ      FARG_ModbusSlave_packRegisters_uintStart+0, 1 
	INCF        FARG_ModbusSlave_packRegisters_uintStart+1, 1 
;ModbusSlave.c,276 :: 		uintOffset++;
	INFSNZ      R5, 1 
	INCF        R6, 1 
;ModbusSlave.c,277 :: 		}
	GOTO        L_ModbusSlave_packRegisters38
L_ModbusSlave_packRegisters39:
;ModbusSlave.c,278 :: 		}
L_ModbusSlave_packRegisters37:
;ModbusSlave.c,279 :: 		return uintBytes;
	MOVF        ModbusSlave_packRegisters_uintBytes_L0+0, 0 
	MOVWF       R0 
	MOVF        ModbusSlave_packRegisters_uintBytes_L0+1, 0 
	MOVWF       R1 
;ModbusSlave.c,280 :: 		}
L_end_packRegisters:
	RETURN      0
; end of ModbusSlave_packRegisters

ModbusSlave_setRegister:

;ModbusSlave.c,293 :: 		static boolean setRegister(uint uintAddress, byte bytDataHi, byte bytDataLo) {
;ModbusSlave.c,295 :: 		if ( pWriteBlock == NULL ) {
	MOVLW       0
	XORWF       ModbusSlave_pWriteBlock+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_setRegister222
	MOVLW       0
	XORWF       ModbusSlave_pWriteBlock+0, 0 
L_ModbusSlave_setRegister222:
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_setRegister40
;ModbusSlave.c,297 :: 		pWriteBlock = pHoldingRegs;
	MOVF        ModbusSlave_pHoldingRegs+0, 0 
	MOVWF       ModbusSlave_pWriteBlock+0 
	MOVF        ModbusSlave_pHoldingRegs+1, 0 
	MOVWF       ModbusSlave_pWriteBlock+1 
;ModbusSlave.c,298 :: 		while( pWriteBlock != NULL ) {
L_ModbusSlave_setRegister41:
	MOVLW       0
	XORWF       ModbusSlave_pWriteBlock+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_setRegister223
	MOVLW       0
	XORWF       ModbusSlave_pWriteBlock+0, 0 
L_ModbusSlave_setRegister223:
	BTFSC       STATUS+0, 2 
	GOTO        L_ModbusSlave_setRegister42
;ModbusSlave.c,299 :: 		if ( uintAddress >= pWriteBlock->uintAddress
	MOVLW       1
	ADDWF       ModbusSlave_pWriteBlock+0, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      ModbusSlave_pWriteBlock+1, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	MOVWF       R1 
	MOVF        POSTINC2+0, 0 
	MOVWF       R2 
;ModbusSlave.c,301 :: 		pWriteBlock->uintTotal - 1)  ) {
	MOVF        R2, 0 
	SUBWF       FARG_ModbusSlave_setRegister_uintAddress+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_setRegister224
	MOVF        R1, 0 
	SUBWF       FARG_ModbusSlave_setRegister_uintAddress+0, 0 
L_ModbusSlave_setRegister224:
	BTFSS       STATUS+0, 0 
	GOTO        L_ModbusSlave_setRegister45
;ModbusSlave.c,300 :: 		&& uintAddress <= (pWriteBlock->uintAddress +
	MOVLW       1
	ADDWF       ModbusSlave_pWriteBlock+0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      ModbusSlave_pWriteBlock+1, 0 
	MOVWF       FSR0H 
;ModbusSlave.c,301 :: 		pWriteBlock->uintTotal - 1)  ) {
	MOVLW       3
	ADDWF       ModbusSlave_pWriteBlock+0, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      ModbusSlave_pWriteBlock+1, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC2+0, 0 
	ADDWFC      POSTINC0+0, 0 
	MOVWF       R1 
	MOVLW       1
	SUBWF       R0, 0 
	MOVWF       R2 
	MOVLW       0
	SUBWFB      R1, 0 
	MOVWF       R3 
	MOVF        FARG_ModbusSlave_setRegister_uintAddress+1, 0 
	SUBWF       R3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_setRegister225
	MOVF        FARG_ModbusSlave_setRegister_uintAddress+0, 0 
	SUBWF       R2, 0 
L_ModbusSlave_setRegister225:
	BTFSS       STATUS+0, 0 
	GOTO        L_ModbusSlave_setRegister45
L_ModbusSlave_setRegister184:
;ModbusSlave.c,302 :: 		break;
	GOTO        L_ModbusSlave_setRegister42
;ModbusSlave.c,303 :: 		}
L_ModbusSlave_setRegister45:
;ModbusSlave.c,304 :: 		pWriteBlock = pWriteBlock->pNext;
	MOVLW       11
	ADDWF       ModbusSlave_pWriteBlock+0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      ModbusSlave_pWriteBlock+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       ModbusSlave_pWriteBlock+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       ModbusSlave_pWriteBlock+1 
;ModbusSlave.c,305 :: 		}
	GOTO        L_ModbusSlave_setRegister41
L_ModbusSlave_setRegister42:
;ModbusSlave.c,306 :: 		}
L_ModbusSlave_setRegister40:
;ModbusSlave.c,307 :: 		if ( pWriteBlock != NULL ) {
	MOVLW       0
	XORWF       ModbusSlave_pWriteBlock+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_ModbusSlave_setRegister226
	MOVLW       0
	XORWF       ModbusSlave_pWriteBlock+0, 0 
L_ModbusSlave_setRegister226:
	BTFSC       STATUS+0, 2 
	GOTO        L_ModbusSlave_setRegister46
;ModbusSlave.c,309 :: 		Lo(uintTemp) = bytDataLo;
	MOVF        FARG_ModbusSlave_setRegister_bytDataLo+0, 0 
	MOVWF       R5 
;ModbusSlave.c,310 :: 		Hi(uintTemp) = bytDataHi;
	MOVF        FARG_ModbusSlave_setRegister_bytDataHi+0, 0 
	MOVWF       R6 
;ModbusSlave.c,311 :: 		uintOffset = uintAddress - pWriteBlock->uintAddress;
	MOVLW       1
	ADDWF       ModbusSlave_pWriteBlock+0, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      ModbusSlave_pWriteBlock+1, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	SUBWF       FARG_ModbusSlave_setRegister_uintAddress+0, 0 
	MOVWF       R3 
	MOVF        POSTINC2+0, 0 
	SUBWFB      FARG_ModbusSlave_setRegister_uintAddress+1, 0 
	MOVWF       R4 
;ModbusSlave.c,312 :: 		((uint*)pWriteBlock->paryData)[uintOffset] = uintTemp;
	MOVLW       5
	ADDWF       ModbusSlave_pWriteBlock+0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      ModbusSlave_pWriteBlock+1, 0 
	MOVWF       FSR0H 
	MOVF        R3, 0 
	MOVWF       R0 
	MOVF        R4, 0 
	MOVWF       R1 
	RLCF        R0, 1 
	BCF         R0, 0 
	RLCF        R1, 1 
	MOVF        R0, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       FSR1 
	MOVF        R1, 0 
	ADDWFC      POSTINC0+0, 0 
	MOVWF       FSR1H 
	MOVF        R5, 0 
	MOVWF       POSTINC1+0 
	MOVF        R6, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,313 :: 		return TRUE;
	MOVLW       1
	MOVWF       R0 
	GOTO        L_end_setRegister
;ModbusSlave.c,314 :: 		}
L_ModbusSlave_setRegister46:
;ModbusSlave.c,315 :: 		return FALSE;
	CLRF        R0 
;ModbusSlave.c,316 :: 		}
L_end_setRegister:
	RETURN      0
; end of ModbusSlave_setRegister

ModbusSlave_startTimeout:

;ModbusSlave.c,327 :: 		static void startTimeout(void) {
;ModbusSlave.c,329 :: 		TMR0ON_bit = 0;
	BCF         TMR0ON_bit+0, 7 
;ModbusSlave.c,331 :: 		if ( bytRxphase.B1 ) {
	BTFSS       ModbusSlave_bytRxphase+0, 1 
	GOTO        L_ModbusSlave_startTimeout47
;ModbusSlave.c,332 :: 		TMR0H = Hi(uintRxGapSetPt3);
	MOVF        ModbusSlave_uintRxGapSetPt3+1, 0 
	MOVWF       TMR0H+0 
;ModbusSlave.c,333 :: 		TMR0L = Lo(uintRxGapSetPt3);
	MOVF        ModbusSlave_uintRxGapSetPt3+0, 0 
	MOVWF       TMR0L+0 
;ModbusSlave.c,334 :: 		} else if ( bytRxphase.B2 ) {
	GOTO        L_ModbusSlave_startTimeout48
L_ModbusSlave_startTimeout47:
	BTFSS       ModbusSlave_bytRxphase+0, 2 
	GOTO        L_ModbusSlave_startTimeout49
;ModbusSlave.c,335 :: 		TMR0H = Hi(uintRxGapSetPt2);
	MOVF        ModbusSlave_uintRxGapSetPt2+1, 0 
	MOVWF       TMR0H+0 
;ModbusSlave.c,336 :: 		TMR0L = Lo(uintRxGapSetPt2);
	MOVF        ModbusSlave_uintRxGapSetPt2+0, 0 
	MOVWF       TMR0L+0 
;ModbusSlave.c,337 :: 		} else if ( bytRxphase.B7 ) {
	GOTO        L_ModbusSlave_startTimeout50
L_ModbusSlave_startTimeout49:
	BTFSS       ModbusSlave_bytRxphase+0, 7 
	GOTO        L_ModbusSlave_startTimeout51
;ModbusSlave.c,338 :: 		TMR0H = Hi(uintRxGapSetPt1);
	MOVF        ModbusSlave_uintRxGapSetPt1+1, 0 
	MOVWF       TMR0H+0 
;ModbusSlave.c,339 :: 		TMR0L = Lo(uintRxGapSetPt1);
	MOVF        ModbusSlave_uintRxGapSetPt1+0, 0 
	MOVWF       TMR0L+0 
;ModbusSlave.c,340 :: 		} else {
	GOTO        L_ModbusSlave_startTimeout52
L_ModbusSlave_startTimeout51:
;ModbusSlave.c,341 :: 		TMR0H = Hi(uintRxGapSetPt);
	MOVF        ModbusSlave_uintRxGapSetPt+1, 0 
	MOVWF       TMR0H+0 
;ModbusSlave.c,342 :: 		TMR0L = Lo(uintRxGapSetPt);
	MOVF        ModbusSlave_uintRxGapSetPt+0, 0 
	MOVWF       TMR0L+0 
;ModbusSlave.c,343 :: 		}
L_ModbusSlave_startTimeout52:
L_ModbusSlave_startTimeout50:
L_ModbusSlave_startTimeout48:
;ModbusSlave.c,345 :: 		TMR0IF_bit = 0;
	BCF         TMR0IF_bit+0, 2 
;ModbusSlave.c,347 :: 		TMR0ON_bit = 1;
	BSF         TMR0ON_bit+0, 7 
;ModbusSlave.c,348 :: 		}
L_end_startTimeout:
	RETURN      0
; end of ModbusSlave_startTimeout

ModbusSlave_restartRx:

;ModbusSlave.c,359 :: 		static void restartRx(void) {
;ModbusSlave.c,361 :: 		bytRxphase = RCREG;
	MOVF        RCREG+0, 0 
	MOVWF       ModbusSlave_bytRxphase+0 
;ModbusSlave.c,362 :: 		bytRxphase = RCREG;
	MOVF        RCREG+0, 0 
	MOVWF       ModbusSlave_bytRxphase+0 
;ModbusSlave.c,364 :: 		CREN_bit = 0;
	BCF         CREN_bit+0, 4 
;ModbusSlave.c,365 :: 		CREN_bit = 1;
	BSF         CREN_bit+0, 4 
;ModbusSlave.c,367 :: 		Tx_dir = 0;
	BCF         LATE+0, 0 
;ModbusSlave.c,373 :: 		bytRxphase = 0;
	CLRF        ModbusSlave_bytRxphase+0 
;ModbusSlave.c,374 :: 		bytIndex = 0;
	CLRF        ModbusSlave_bytIndex+0 
;ModbusSlave.c,376 :: 		TXEN_bit = 0;
	BCF         TXEN_bit+0, 5 
;ModbusSlave.c,377 :: 		TXIE_bit = 0;
	BCF         TXIE_bit+0, 4 
;ModbusSlave.c,379 :: 		RCIE_bit = 1;
	BSF         RCIE_bit+0, 5 
;ModbusSlave.c,380 :: 		startTimeout();
	CALL        ModbusSlave_startTimeout+0, 0
;ModbusSlave.c,381 :: 		}
L_end_restartRx:
	RETURN      0
; end of ModbusSlave_restartRx

_addModbusBlock:

;ModbusSlave.c,404 :: 		void (*pCallback)(modbusBlockDef*)) {
;ModbusSlave.c,409 :: 		|| uintAddress == 0
	MOVLW       0
	XORWF       FARG_addModbusBlock_pBlock+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__addModbusBlock230
	MOVLW       0
	XORWF       FARG_addModbusBlock_pBlock+0, 0 
L__addModbusBlock230:
	BTFSC       STATUS+0, 2 
	GOTO        L__addModbusBlock186
	MOVLW       0
	XORWF       FARG_addModbusBlock_uintAddress+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__addModbusBlock231
	MOVLW       0
	XORWF       FARG_addModbusBlock_uintAddress+0, 0 
L__addModbusBlock231:
	BTFSC       STATUS+0, 2 
	GOTO        L__addModbusBlock186
;ModbusSlave.c,410 :: 		|| uintTotal == 0
	MOVLW       0
	XORWF       FARG_addModbusBlock_uintTotal+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__addModbusBlock232
	MOVLW       0
	XORWF       FARG_addModbusBlock_uintTotal+0, 0 
L__addModbusBlock232:
	BTFSC       STATUS+0, 2 
	GOTO        L__addModbusBlock186
;ModbusSlave.c,411 :: 		|| paryData == NULL ) {
	MOVLW       0
	XORWF       FARG_addModbusBlock_paryData+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__addModbusBlock233
	MOVLW       0
	XORWF       FARG_addModbusBlock_paryData+0, 0 
L__addModbusBlock233:
	BTFSC       STATUS+0, 2 
	GOTO        L__addModbusBlock186
	GOTO        L_addModbusBlock55
L__addModbusBlock186:
;ModbusSlave.c,412 :: 		return FALSE;
	CLRF        R0 
	GOTO        L_end_addModbusBlock
;ModbusSlave.c,413 :: 		}
L_addModbusBlock55:
;ModbusSlave.c,414 :: 		if ( eType == COILS ) {
	MOVF        FARG_addModbusBlock_eType+0, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_addModbusBlock56
;ModbusSlave.c,415 :: 		pLL   = &pCoils;
	MOVLW       ModbusSlave_pCoils+0
	MOVWF       R8 
	MOVLW       hi_addr(ModbusSlave_pCoils+0)
	MOVWF       R9 
;ModbusSlave.c,416 :: 		pTail = &pCoilsTail;
	MOVLW       ModbusSlave_pCoilsTail+0
	MOVWF       R6 
	MOVLW       hi_addr(ModbusSlave_pCoilsTail+0)
	MOVWF       R7 
;ModbusSlave.c,417 :: 		} else if ( eType == STATUS_INPUTS ) {
	GOTO        L_addModbusBlock57
L_addModbusBlock56:
	MOVF        FARG_addModbusBlock_eType+0, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L_addModbusBlock58
;ModbusSlave.c,418 :: 		pLL   = &pStatusBits;
	MOVLW       ModbusSlave_pStatusBits+0
	MOVWF       R8 
	MOVLW       hi_addr(ModbusSlave_pStatusBits+0)
	MOVWF       R9 
;ModbusSlave.c,419 :: 		pTail = &pStatusBitsTail;
	MOVLW       ModbusSlave_pStatusBitsTail+0
	MOVWF       R6 
	MOVLW       hi_addr(ModbusSlave_pStatusBitsTail+0)
	MOVWF       R7 
;ModbusSlave.c,420 :: 		} else if ( eType == HOLDING_REGISTERS ) {
	GOTO        L_addModbusBlock59
L_addModbusBlock58:
	MOVF        FARG_addModbusBlock_eType+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_addModbusBlock60
;ModbusSlave.c,421 :: 		pLL   = &pHoldingRegs;
	MOVLW       ModbusSlave_pHoldingRegs+0
	MOVWF       R8 
	MOVLW       hi_addr(ModbusSlave_pHoldingRegs+0)
	MOVWF       R9 
;ModbusSlave.c,422 :: 		pTail = &pHoldingRegsTail;
	MOVLW       ModbusSlave_pHoldingRegsTail+0
	MOVWF       R6 
	MOVLW       hi_addr(ModbusSlave_pHoldingRegsTail+0)
	MOVWF       R7 
;ModbusSlave.c,423 :: 		} else if ( eType == INPUT_REGISTERS ) {
	GOTO        L_addModbusBlock61
L_addModbusBlock60:
	MOVF        FARG_addModbusBlock_eType+0, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_addModbusBlock62
;ModbusSlave.c,424 :: 		pLL   = &pInputRegs;
	MOVLW       ModbusSlave_pInputRegs+0
	MOVWF       R8 
	MOVLW       hi_addr(ModbusSlave_pInputRegs+0)
	MOVWF       R9 
;ModbusSlave.c,425 :: 		pTail = &pInputRegsTail;
	MOVLW       ModbusSlave_pInputRegsTail+0
	MOVWF       R6 
	MOVLW       hi_addr(ModbusSlave_pInputRegsTail+0)
	MOVWF       R7 
;ModbusSlave.c,426 :: 		} else {
	GOTO        L_addModbusBlock63
L_addModbusBlock62:
;ModbusSlave.c,427 :: 		return FALSE;
	CLRF        R0 
	GOTO        L_end_addModbusBlock
;ModbusSlave.c,428 :: 		}
L_addModbusBlock63:
L_addModbusBlock61:
L_addModbusBlock59:
L_addModbusBlock57:
;ModbusSlave.c,429 :: 		if ( *pLL == NULL ) {
	MOVFF       R8, FSR0
	MOVFF       R9, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R2 
	MOVLW       0
	XORWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__addModbusBlock234
	MOVLW       0
	XORWF       R1, 0 
L__addModbusBlock234:
	BTFSS       STATUS+0, 2 
	GOTO        L_addModbusBlock64
;ModbusSlave.c,431 :: 		*pLL = *pTail = pBlock;
	MOVFF       R6, FSR1
	MOVFF       R7, FSR1H
	MOVF        FARG_addModbusBlock_pBlock+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_addModbusBlock_pBlock+1, 0 
	MOVWF       POSTINC1+0 
	MOVFF       R8, FSR1
	MOVFF       R9, FSR1H
	MOVFF       R6, FSR0
	MOVFF       R7, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        POSTINC0+0, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,432 :: 		} else {
	GOTO        L_addModbusBlock65
L_addModbusBlock64:
;ModbusSlave.c,435 :: 		for( pNode=*pLL; pNode!=NULL; pNode=pNode->pNext ) {
	MOVFF       R8, FSR0
	MOVFF       R9, FSR0H
	MOVF        POSTINC0+0, 0 
	MOVWF       R4 
	MOVF        POSTINC0+0, 0 
	MOVWF       R5 
L_addModbusBlock66:
	MOVLW       0
	XORWF       R5, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__addModbusBlock235
	MOVLW       0
	XORWF       R4, 0 
L__addModbusBlock235:
	BTFSC       STATUS+0, 2 
	GOTO        L_addModbusBlock67
;ModbusSlave.c,436 :: 		if ( uintAddress >= pNode->uintAddress
	MOVLW       1
	ADDWF       R4, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      R5, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	MOVWF       R1 
	MOVF        POSTINC2+0, 0 
	MOVWF       R2 
;ModbusSlave.c,437 :: 		&& uintAddress <= (pNode->uintAddress + pNode->uintTotal - 1)  ) {
	MOVF        R2, 0 
	SUBWF       FARG_addModbusBlock_uintAddress+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__addModbusBlock236
	MOVF        R1, 0 
	SUBWF       FARG_addModbusBlock_uintAddress+0, 0 
L__addModbusBlock236:
	BTFSS       STATUS+0, 0 
	GOTO        L_addModbusBlock71
	MOVLW       1
	ADDWF       R4, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R5, 0 
	MOVWF       FSR0H 
	MOVLW       3
	ADDWF       R4, 0 
	MOVWF       FSR2 
	MOVLW       0
	ADDWFC      R5, 0 
	MOVWF       FSR2H 
	MOVF        POSTINC2+0, 0 
	ADDWF       POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC2+0, 0 
	ADDWFC      POSTINC0+0, 0 
	MOVWF       R1 
	MOVLW       1
	SUBWF       R0, 0 
	MOVWF       R2 
	MOVLW       0
	SUBWFB      R1, 0 
	MOVWF       R3 
	MOVF        FARG_addModbusBlock_uintAddress+1, 0 
	SUBWF       R3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__addModbusBlock237
	MOVF        FARG_addModbusBlock_uintAddress+0, 0 
	SUBWF       R2, 0 
L__addModbusBlock237:
	BTFSS       STATUS+0, 0 
	GOTO        L_addModbusBlock71
L__addModbusBlock185:
;ModbusSlave.c,439 :: 		return FALSE;
	CLRF        R0 
	GOTO        L_end_addModbusBlock
;ModbusSlave.c,440 :: 		}
L_addModbusBlock71:
;ModbusSlave.c,435 :: 		for( pNode=*pLL; pNode!=NULL; pNode=pNode->pNext ) {
	MOVLW       11
	ADDWF       R4, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      R5, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R4 
	MOVF        POSTINC0+0, 0 
	MOVWF       R5 
;ModbusSlave.c,441 :: 		}
	GOTO        L_addModbusBlock66
L_addModbusBlock67:
;ModbusSlave.c,443 :: 		(*pTail)->pNext = pBlock;
	MOVFF       R6, FSR0
	MOVFF       R7, FSR0H
	MOVLW       11
	ADDWF       POSTINC0+0, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      POSTINC0+0, 0 
	MOVWF       FSR1H 
	MOVF        FARG_addModbusBlock_pBlock+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_addModbusBlock_pBlock+1, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,445 :: 		*pTail = pBlock;
	MOVFF       R6, FSR1
	MOVFF       R7, FSR1H
	MOVF        FARG_addModbusBlock_pBlock+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_addModbusBlock_pBlock+1, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,446 :: 		}
L_addModbusBlock65:
;ModbusSlave.c,448 :: 		pBlock->eType       = eType;
	MOVFF       FARG_addModbusBlock_pBlock+0, FSR1
	MOVFF       FARG_addModbusBlock_pBlock+1, FSR1H
	MOVF        FARG_addModbusBlock_eType+0, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,449 :: 		pBlock->uintAddress = uintAddress;
	MOVLW       1
	ADDWF       FARG_addModbusBlock_pBlock+0, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      FARG_addModbusBlock_pBlock+1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_addModbusBlock_uintAddress+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_addModbusBlock_uintAddress+1, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,450 :: 		pBlock->uintTotal   = uintTotal;
	MOVLW       3
	ADDWF       FARG_addModbusBlock_pBlock+0, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      FARG_addModbusBlock_pBlock+1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_addModbusBlock_uintTotal+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_addModbusBlock_uintTotal+1, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,451 :: 		pBlock->paryData    = paryData;
	MOVLW       5
	ADDWF       FARG_addModbusBlock_pBlock+0, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      FARG_addModbusBlock_pBlock+1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_addModbusBlock_paryData+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_addModbusBlock_paryData+1, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,452 :: 		pBlock->pCallback   = pCallback;
	MOVLW       7
	ADDWF       FARG_addModbusBlock_pBlock+0, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      FARG_addModbusBlock_pBlock+1, 0 
	MOVWF       FSR1H 
	MOVF        FARG_addModbusBlock_pCallback+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_addModbusBlock_pCallback+1, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_addModbusBlock_pCallback+2, 0 
	MOVWF       POSTINC1+0 
	MOVF        FARG_addModbusBlock_pCallback+3, 0 
	MOVWF       POSTINC1+0 
;ModbusSlave.c,453 :: 		pBlock->pNext       = NULL;
	MOVLW       11
	ADDWF       FARG_addModbusBlock_pBlock+0, 0 
	MOVWF       FSR1 
	MOVLW       0
	ADDWFC      FARG_addModbusBlock_pBlock+1, 0 
	MOVWF       FSR1H 
	CLRF        POSTINC1+0 
	CLRF        POSTINC1+0 
;ModbusSlave.c,454 :: 		}
L_end_addModbusBlock:
	RETURN      0
; end of _addModbusBlock

_decodePacket:

;ModbusSlave.c,467 :: 		void decodePacket(void) {
;ModbusSlave.c,468 :: 		if ( TMR0IF_bit ) {
	BTFSS       TMR0IF_bit+0, 2 
	GOTO        L_decodePacket72
;ModbusSlave.c,469 :: 		bytRxphase.B0 = 1;
	BSF         ModbusSlave_bytRxphase+0, 0 
;ModbusSlave.c,470 :: 		TMR0ON_bit = 0;
	BCF         TMR0ON_bit+0, 7 
;ModbusSlave.c,472 :: 		TMR0IF_bit = 0;
	BCF         TMR0IF_bit+0, 2 
;ModbusSlave.c,474 :: 		if ( bytRxphase.B7 ) {
	BTFSS       ModbusSlave_bytRxphase+0, 7 
	GOTO        L_decodePacket73
;ModbusSlave.c,476 :: 		restartRx();
	CALL        ModbusSlave_restartRx+0, 0
;ModbusSlave.c,477 :: 		return;
	GOTO        L_end_decodePacket
;ModbusSlave.c,478 :: 		}
L_decodePacket73:
;ModbusSlave.c,479 :: 		}
L_decodePacket72:
;ModbusSlave.c,480 :: 		if( RCIF_bit ) {
	BTFSS       RCIF_bit+0, 5 
	GOTO        L_decodePacket74
;ModbusSlave.c,483 :: 		if ( OERR_bit || FERR_bit ) {
	BTFSC       OERR_bit+0, 1 
	GOTO        L__decodePacket195
	BTFSC       FERR_bit+0, 2 
	GOTO        L__decodePacket195
	GOTO        L_decodePacket77
L__decodePacket195:
;ModbusSlave.c,484 :: 		restartRx();
	CALL        ModbusSlave_restartRx+0, 0
;ModbusSlave.c,485 :: 		return;
	GOTO        L_end_decodePacket
;ModbusSlave.c,486 :: 		}
L_decodePacket77:
;ModbusSlave.c,489 :: 		bytTemp = RCREG;
	MOVF        RCREG+0, 0 
	MOVWF       decodePacket_bytTemp_L1+0 
;ModbusSlave.c,492 :: 		if ( bytRxphase == 0 || bytRxphase.B2 == 1 ||
	MOVF        ModbusSlave_bytRxphase+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L__decodePacket194
	BTFSC       ModbusSlave_bytRxphase+0, 2 
	GOTO        L__decodePacket194
;ModbusSlave.c,493 :: 		bytIndex >= MAX_PACKET_LENGTH ) {
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORLW       1
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket239
	MOVLW       0
	SUBWF       ModbusSlave_bytIndex+0, 0 
L__decodePacket239:
	BTFSC       STATUS+0, 0 
	GOTO        L__decodePacket194
	GOTO        L_decodePacket80
L__decodePacket194:
;ModbusSlave.c,495 :: 		bytIndex = 0;
	CLRF        ModbusSlave_bytIndex+0 
;ModbusSlave.c,496 :: 		bytRxphase = 0;
	CLRF        ModbusSlave_bytRxphase+0 
;ModbusSlave.c,497 :: 		startTimeout();  // 4.5 chars
	CALL        ModbusSlave_startTimeout+0, 0
;ModbusSlave.c,498 :: 		return;
	GOTO        L_end_decodePacket
;ModbusSlave.c,499 :: 		}
L_decodePacket80:
;ModbusSlave.c,500 :: 		if ( bytIndex == 0) {
	MOVF        ModbusSlave_bytIndex+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket81
;ModbusSlave.c,502 :: 		bytRxphase = 2;
	MOVLW       2
	MOVWF       ModbusSlave_bytRxphase+0 
;ModbusSlave.c,503 :: 		}
L_decodePacket81:
;ModbusSlave.c,505 :: 		aryBuffer[bytIndex++] = bytTemp;
	MOVLW       ModbusSlave_aryBuffer+0
	MOVWF       FSR1 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+0)
	MOVWF       FSR1H 
	MOVF        ModbusSlave_bytIndex+0, 0 
	ADDWF       FSR1, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR1H, 1 
	MOVF        decodePacket_bytTemp_L1+0, 0 
	MOVWF       POSTINC1+0 
	INCF        ModbusSlave_bytIndex+0, 1 
;ModbusSlave.c,507 :: 		startTimeout();  // 2.5 chars
	CALL        ModbusSlave_startTimeout+0, 0
;ModbusSlave.c,508 :: 		} else if ( bytRxphase.B7 ) {
	GOTO        L_decodePacket82
L_decodePacket74:
	BTFSS       ModbusSlave_bytRxphase+0, 7 
	GOTO        L_decodePacket83
;ModbusSlave.c,509 :: 		if ( TXIF_bit ) {
	BTFSS       TXIF_bit+0, 4 
	GOTO        L_decodePacket84
;ModbusSlave.c,510 :: 		if ( bytIndex < aryBuffer[0] ) {
	MOVF        ModbusSlave_aryBuffer+0, 0 
	SUBWF       ModbusSlave_bytIndex+0, 0 
	BTFSC       STATUS+0, 0 
	GOTO        L_decodePacket85
;ModbusSlave.c,511 :: 		TXREG=aryBuffer[bytIndex++];
	MOVLW       ModbusSlave_aryBuffer+0
	MOVWF       FSR0 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+0)
	MOVWF       FSR0H 
	MOVF        ModbusSlave_bytIndex+0, 0 
	ADDWF       FSR0, 1 
	BTFSC       STATUS+0, 0 
	INCF        FSR0H, 1 
	MOVF        POSTINC0+0, 0 
	MOVWF       TXREG+0 
	INCF        ModbusSlave_bytIndex+0, 1 
;ModbusSlave.c,512 :: 		} else {
	GOTO        L_decodePacket86
L_decodePacket85:
;ModbusSlave.c,514 :: 		startTimeout();  // 1 char
	CALL        ModbusSlave_startTimeout+0, 0
;ModbusSlave.c,516 :: 		TXIE_bit = 0;
	BCF         TXIE_bit+0, 4 
;ModbusSlave.c,517 :: 		}
L_decodePacket86:
;ModbusSlave.c,518 :: 		return;
	GOTO        L_end_decodePacket
;ModbusSlave.c,519 :: 		}
L_decodePacket84:
;ModbusSlave.c,520 :: 		}
L_decodePacket83:
L_decodePacket82:
;ModbusSlave.c,521 :: 		if ( bytRxphase == 3 ) {
	MOVF        ModbusSlave_bytRxphase+0, 0 
	XORLW       3
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket87
;ModbusSlave.c,523 :: 		bytRxphase = 4;
	MOVLW       4
	MOVWF       ModbusSlave_bytRxphase+0 
;ModbusSlave.c,524 :: 		startTimeout(); // 2 chars
	CALL        ModbusSlave_startTimeout+0, 0
;ModbusSlave.c,525 :: 		}
L_decodePacket87:
;ModbusSlave.c,526 :: 		if ( bytRxphase != 5 ) {
	MOVF        ModbusSlave_bytRxphase+0, 0 
	XORLW       5
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket88
;ModbusSlave.c,528 :: 		return;
	GOTO        L_end_decodePacket
;ModbusSlave.c,529 :: 		}
L_decodePacket88:
;ModbusSlave.c,531 :: 		if (aryBuffer[0] == bytSlaveAddress ) {
	MOVF        ModbusSlave_aryBuffer+0, 0 
	XORWF       ModbusSlave_bytSlaveAddress+0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket89
;ModbusSlave.c,534 :: 		uintCRCpos = 6;
	MOVLW       6
	MOVWF       decodePacket_uintCRCpos_L1+0 
	MOVLW       0
	MOVWF       decodePacket_uintCRCpos_L1+1 
;ModbusSlave.c,536 :: 		switch( aryBuffer[1] ) {
	GOTO        L_decodePacket90
;ModbusSlave.c,537 :: 		case READ_COILS:
L_decodePacket92:
;ModbusSlave.c,538 :: 		case FORCE_SINGLE_COIL:
L_decodePacket93:
;ModbusSlave.c,539 :: 		case FORCE_MULTIPLE_COILS:
L_decodePacket94:
;ModbusSlave.c,540 :: 		if ( pCoils == NULL ) {
	MOVLW       0
	XORWF       ModbusSlave_pCoils+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket240
	MOVLW       0
	XORWF       ModbusSlave_pCoils+0, 0 
L__decodePacket240:
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket95
;ModbusSlave.c,542 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,543 :: 		}
L_decodePacket95:
;ModbusSlave.c,544 :: 		break;
	GOTO        L_decodePacket91
;ModbusSlave.c,545 :: 		case READ_STATUS_INPUTS:
L_decodePacket96:
;ModbusSlave.c,546 :: 		if ( pStatusBits == NULL ) {
	MOVLW       0
	XORWF       ModbusSlave_pStatusBits+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket241
	MOVLW       0
	XORWF       ModbusSlave_pStatusBits+0, 0 
L__decodePacket241:
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket97
;ModbusSlave.c,548 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,549 :: 		}
L_decodePacket97:
;ModbusSlave.c,550 :: 		break;
	GOTO        L_decodePacket91
;ModbusSlave.c,551 :: 		case READ_HOLDING_REGISTERS:
L_decodePacket98:
;ModbusSlave.c,552 :: 		case PRESET_SINGLE_REGISTER:
L_decodePacket99:
;ModbusSlave.c,553 :: 		case PRESET_MULTIPLE_REGISTERS:
L_decodePacket100:
;ModbusSlave.c,554 :: 		if ( pHoldingRegs == NULL ) {
	MOVLW       0
	XORWF       ModbusSlave_pHoldingRegs+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket242
	MOVLW       0
	XORWF       ModbusSlave_pHoldingRegs+0, 0 
L__decodePacket242:
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket101
;ModbusSlave.c,556 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,557 :: 		}
L_decodePacket101:
;ModbusSlave.c,558 :: 		break;
	GOTO        L_decodePacket91
;ModbusSlave.c,559 :: 		case READ_INPUT_REGISTERS:
L_decodePacket102:
;ModbusSlave.c,560 :: 		if ( pInputRegs == NULL ) {
	MOVLW       0
	XORWF       ModbusSlave_pInputRegs+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket243
	MOVLW       0
	XORWF       ModbusSlave_pInputRegs+0, 0 
L__decodePacket243:
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket103
;ModbusSlave.c,562 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,563 :: 		}
L_decodePacket103:
;ModbusSlave.c,564 :: 		break;
	GOTO        L_decodePacket91
;ModbusSlave.c,565 :: 		default:
L_decodePacket104:
;ModbusSlave.c,567 :: 		exceptionCode = ILLEGAL_FUNCTION;
	MOVLW       1
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,568 :: 		break;
	GOTO        L_decodePacket91
;ModbusSlave.c,569 :: 		}
L_decodePacket90:
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket92
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       5
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket93
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       15
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket94
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket96
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       3
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket98
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       6
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket99
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       16
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket100
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       4
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket102
	GOTO        L_decodePacket104
L_decodePacket91:
;ModbusSlave.c,570 :: 		bytStartHi = aryBuffer[2];
	MOVF        ModbusSlave_aryBuffer+2, 0 
	MOVWF       ModbusSlave_bytStartHi+0 
;ModbusSlave.c,571 :: 		bytStartLo = aryBuffer[3];
	MOVF        ModbusSlave_aryBuffer+3, 0 
	MOVWF       ModbusSlave_bytStartLo+0 
;ModbusSlave.c,572 :: 		bytTotalHi = aryBuffer[4];
	MOVF        ModbusSlave_aryBuffer+4, 0 
	MOVWF       ModbusSlave_bytTotalHi+0 
;ModbusSlave.c,573 :: 		bytTotalLo = aryBuffer[5];
	MOVF        ModbusSlave_aryBuffer+5, 0 
	MOVWF       ModbusSlave_bytTotalLo+0 
;ModbusSlave.c,576 :: 		aryBuffer[1] == PRESET_MULTIPLE_REGISTERS )  {
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       15
	BTFSC       STATUS+0, 2 
	GOTO        L__decodePacket193
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       16
	BTFSC       STATUS+0, 2 
	GOTO        L__decodePacket193
	GOTO        L_decodePacket107
L__decodePacket193:
;ModbusSlave.c,577 :: 		uintCRCpos += 1 + aryBuffer[6];
	MOVF        ModbusSlave_aryBuffer+6, 0 
	ADDLW       1
	MOVWF       R0 
	CLRF        R1 
	MOVLW       0
	ADDWFC      R1, 1 
	MOVF        R0, 0 
	ADDWF       decodePacket_uintCRCpos_L1+0, 1 
	MOVF        R1, 0 
	ADDWFC      decodePacket_uintCRCpos_L1+1, 1 
;ModbusSlave.c,578 :: 		}
L_decodePacket107:
;ModbusSlave.c,580 :: 		uintCRC = calcCRC(uintCRCpos);
	MOVF        decodePacket_uintCRCpos_L1+0, 0 
	MOVWF       FARG_ModbusSlave_calcCRC_uintLength+0 
	MOVF        decodePacket_uintCRCpos_L1+1, 0 
	MOVWF       FARG_ModbusSlave_calcCRC_uintLength+1 
	CALL        ModbusSlave_calcCRC+0, 0
	MOVF        R0, 0 
	MOVWF       decodePacket_uintCRC_L1+0 
	MOVF        R1, 0 
	MOVWF       decodePacket_uintCRC_L1+1 
;ModbusSlave.c,582 :: 		if ( Lo(uintCRC)  == aryBuffer[uintCRCpos] &&
	MOVLW       ModbusSlave_aryBuffer+0
	ADDWF       decodePacket_uintCRCpos_L1+0, 0 
	MOVWF       FSR2 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+0)
	ADDWFC      decodePacket_uintCRCpos_L1+1, 0 
	MOVWF       FSR2H 
;ModbusSlave.c,583 :: 		Hi(uintCRC) == aryBuffer[uintCRCpos + 1] ) {
	MOVF        decodePacket_uintCRC_L1+0, 0 
	XORWF       POSTINC2+0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket110
	MOVLW       1
	ADDWF       decodePacket_uintCRCpos_L1+0, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      decodePacket_uintCRCpos_L1+1, 0 
	MOVWF       R1 
	MOVLW       ModbusSlave_aryBuffer+0
	ADDWF       R0, 0 
	MOVWF       FSR2 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+0)
	ADDWFC      R1, 0 
	MOVWF       FSR2H 
	MOVF        decodePacket_uintCRC_L1+1, 0 
	XORWF       POSTINC2+0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket110
L__decodePacket192:
;ModbusSlave.c,585 :: 		uint uintSAddr, uintEAddr, uintItemCount, uintLength = 6;
	MOVLW       6
	MOVWF       decodePacket_uintLength_L2+0 
	MOVLW       0
	MOVWF       decodePacket_uintLength_L2+1 
;ModbusSlave.c,591 :: 		Lo(uintSAddr) = bytStartLo;
	MOVF        ModbusSlave_bytStartLo+0, 0 
	MOVWF       decodePacket_uintSAddr_L2+0 
;ModbusSlave.c,592 :: 		Hi(uintSAddr) = bytStartHi;
	MOVF        ModbusSlave_bytStartHi+0, 0 
	MOVWF       decodePacket_uintSAddr_L2+1 
;ModbusSlave.c,594 :: 		Lo(uintItemCount) = bytTotalLo;
	MOVF        ModbusSlave_bytTotalLo+0, 0 
	MOVWF       decodePacket_uintItemCount_L2+0 
;ModbusSlave.c,595 :: 		Hi(uintItemCount) = bytTotalHi;
	MOVF        ModbusSlave_bytTotalHi+0, 0 
	MOVWF       decodePacket_uintItemCount_L2+1 
;ModbusSlave.c,597 :: 		uintEAddr = uintSAddr + uintItemCount;
	MOVF        decodePacket_uintItemCount_L2+0, 0 
	ADDWF       decodePacket_uintSAddr_L2+0, 0 
	MOVWF       decodePacket_uintEAddr_L2+0 
	MOVF        decodePacket_uintItemCount_L2+1, 0 
	ADDWFC      decodePacket_uintSAddr_L2+1, 0 
	MOVWF       decodePacket_uintEAddr_L2+1 
;ModbusSlave.c,598 :: 		uintSAddr++;
	INFSNZ      decodePacket_uintSAddr_L2+0, 1 
	INCF        decodePacket_uintSAddr_L2+1, 1 
;ModbusSlave.c,600 :: 		pWriteBlock = NULL;
	CLRF        ModbusSlave_pWriteBlock+0 
	CLRF        ModbusSlave_pWriteBlock+1 
;ModbusSlave.c,602 :: 		switch( aryBuffer[1] ) {
	GOTO        L_decodePacket111
;ModbusSlave.c,603 :: 		case READ_COILS:
L_decodePacket113:
;ModbusSlave.c,604 :: 		case READ_STATUS_INPUTS:
L_decodePacket114:
;ModbusSlave.c,605 :: 		if ( aryBuffer[1] == READ_COILS ) {
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket115
;ModbusSlave.c,606 :: 		eType = COILS;
	MOVLW       1
	MOVWF       decodePacket_eType_L2+0 
;ModbusSlave.c,607 :: 		} else {
	GOTO        L_decodePacket116
L_decodePacket115:
;ModbusSlave.c,608 :: 		eType = STATUS_INPUTS;
	MOVLW       2
	MOVWF       decodePacket_eType_L2+0 
;ModbusSlave.c,609 :: 		}
L_decodePacket116:
;ModbusSlave.c,610 :: 		aryBuffer[2] = packBits(eType, &aryBuffer[3], uintSAddr, uintEAddr);
	MOVF        decodePacket_eType_L2+0, 0 
	MOVWF       FARG_ModbusSlave_packBits_eType+0 
	MOVLW       ModbusSlave_aryBuffer+3
	MOVWF       FARG_ModbusSlave_packBits_pBuffer+0 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+3)
	MOVWF       FARG_ModbusSlave_packBits_pBuffer+1 
	MOVF        decodePacket_uintSAddr_L2+0, 0 
	MOVWF       FARG_ModbusSlave_packBits_uintStart+0 
	MOVF        decodePacket_uintSAddr_L2+1, 0 
	MOVWF       FARG_ModbusSlave_packBits_uintStart+1 
	MOVF        decodePacket_uintEAddr_L2+0, 0 
	MOVWF       FARG_ModbusSlave_packBits_uintEnd+0 
	MOVF        decodePacket_uintEAddr_L2+1, 0 
	MOVWF       FARG_ModbusSlave_packBits_uintEnd+1 
	CALL        ModbusSlave_packBits+0, 0
	MOVF        R0, 0 
	MOVWF       ModbusSlave_aryBuffer+2 
;ModbusSlave.c,612 :: 		if ( aryBuffer[2] == 0 ) {
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket117
;ModbusSlave.c,614 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,615 :: 		} else {
	GOTO        L_decodePacket118
L_decodePacket117:
;ModbusSlave.c,616 :: 		uintLength = aryBuffer[2] + 3;
	MOVLW       3
	ADDWF       ModbusSlave_aryBuffer+2, 0 
	MOVWF       decodePacket_uintLength_L2+0 
	CLRF        decodePacket_uintLength_L2+1 
	MOVLW       0
	ADDWFC      decodePacket_uintLength_L2+1, 1 
;ModbusSlave.c,617 :: 		}
L_decodePacket118:
;ModbusSlave.c,618 :: 		break;
	GOTO        L_decodePacket112
;ModbusSlave.c,619 :: 		case READ_HOLDING_REGISTERS:
L_decodePacket119:
;ModbusSlave.c,620 :: 		case READ_INPUT_REGISTERS:
L_decodePacket120:
;ModbusSlave.c,621 :: 		if ( aryBuffer[1] == READ_INPUT_REGISTERS ) {
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket121
;ModbusSlave.c,622 :: 		eType = INPUT_REGISTERS;
	MOVLW       4
	MOVWF       decodePacket_eType_L2+0 
;ModbusSlave.c,623 :: 		} else {
	GOTO        L_decodePacket122
L_decodePacket121:
;ModbusSlave.c,624 :: 		eType = HOLDING_REGISTERS;
	MOVLW       3
	MOVWF       decodePacket_eType_L2+0 
;ModbusSlave.c,625 :: 		}
L_decodePacket122:
;ModbusSlave.c,626 :: 		aryBuffer[2] = packRegisters(eType, &aryBuffer[3],
	MOVF        decodePacket_eType_L2+0, 0 
	MOVWF       FARG_ModbusSlave_packRegisters_eType+0 
	MOVLW       ModbusSlave_aryBuffer+3
	MOVWF       FARG_ModbusSlave_packRegisters_pBuffer+0 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+3)
	MOVWF       FARG_ModbusSlave_packRegisters_pBuffer+1 
;ModbusSlave.c,627 :: 		uintSAddr, uintEAddr);
	MOVF        decodePacket_uintSAddr_L2+0, 0 
	MOVWF       FARG_ModbusSlave_packRegisters_uintStart+0 
	MOVF        decodePacket_uintSAddr_L2+1, 0 
	MOVWF       FARG_ModbusSlave_packRegisters_uintStart+1 
	MOVF        decodePacket_uintEAddr_L2+0, 0 
	MOVWF       FARG_ModbusSlave_packRegisters_uintEnd+0 
	MOVF        decodePacket_uintEAddr_L2+1, 0 
	MOVWF       FARG_ModbusSlave_packRegisters_uintEnd+1 
	CALL        ModbusSlave_packRegisters+0, 0
	MOVF        R0, 0 
	MOVWF       ModbusSlave_aryBuffer+2 
;ModbusSlave.c,628 :: 		if ( aryBuffer[2] == 0 ) {
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket123
;ModbusSlave.c,630 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,631 :: 		} else {
	GOTO        L_decodePacket124
L_decodePacket123:
;ModbusSlave.c,632 :: 		uintLength = aryBuffer[2] + 3;
	MOVLW       3
	ADDWF       ModbusSlave_aryBuffer+2, 0 
	MOVWF       decodePacket_uintLength_L2+0 
	CLRF        decodePacket_uintLength_L2+1 
	MOVLW       0
	ADDWFC      decodePacket_uintLength_L2+1, 1 
;ModbusSlave.c,633 :: 		}
L_decodePacket124:
;ModbusSlave.c,634 :: 		break;
	GOTO        L_decodePacket112
;ModbusSlave.c,635 :: 		case FORCE_SINGLE_COIL:
L_decodePacket125:
;ModbusSlave.c,636 :: 		if ( aryBuffer[4] == 0xff && aryBuffer[5] == 0x0 ) {
	MOVF        ModbusSlave_aryBuffer+4, 0 
	XORLW       255
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket128
	MOVF        ModbusSlave_aryBuffer+5, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket128
L__decodePacket191:
;ModbusSlave.c,638 :: 		blnState = coilState(uintSAddr, TRUE);
	MOVF        decodePacket_uintSAddr_L2+0, 0 
	MOVWF       FARG_ModbusSlave_coilState_uintAddress+0 
	MOVF        decodePacket_uintSAddr_L2+1, 0 
	MOVWF       FARG_ModbusSlave_coilState_uintAddress+1 
	MOVLW       1
	MOVWF       FARG_ModbusSlave_coilState_blnState+0 
	CALL        ModbusSlave_coilState+0, 0
	MOVF        R0, 0 
	MOVWF       decodePacket_blnState_L2+0 
;ModbusSlave.c,639 :: 		} else if ( aryBuffer[4] == 0x0 && aryBuffer[5] == 0x0 ) {
	GOTO        L_decodePacket129
L_decodePacket128:
	MOVF        ModbusSlave_aryBuffer+4, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket132
	MOVF        ModbusSlave_aryBuffer+5, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket132
L__decodePacket190:
;ModbusSlave.c,641 :: 		blnState = coilState(uintSAddr, FALSE);
	MOVF        decodePacket_uintSAddr_L2+0, 0 
	MOVWF       FARG_ModbusSlave_coilState_uintAddress+0 
	MOVF        decodePacket_uintSAddr_L2+1, 0 
	MOVWF       FARG_ModbusSlave_coilState_uintAddress+1 
	CLRF        FARG_ModbusSlave_coilState_blnState+0 
	CALL        ModbusSlave_coilState+0, 0
	MOVF        R0, 0 
	MOVWF       decodePacket_blnState_L2+0 
;ModbusSlave.c,642 :: 		}
L_decodePacket132:
L_decodePacket129:
;ModbusSlave.c,643 :: 		if ( blnState == FALSE ) {
	MOVF        decodePacket_blnState_L2+0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket133
;ModbusSlave.c,645 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,646 :: 		}
L_decodePacket133:
;ModbusSlave.c,647 :: 		break;
	GOTO        L_decodePacket112
;ModbusSlave.c,648 :: 		case PRESET_SINGLE_REGISTER:
L_decodePacket134:
;ModbusSlave.c,649 :: 		if ( setRegister(uintSAddr, aryBuffer[4], aryBuffer[5]) == FALSE ) {
	MOVF        decodePacket_uintSAddr_L2+0, 0 
	MOVWF       FARG_ModbusSlave_setRegister_uintAddress+0 
	MOVF        decodePacket_uintSAddr_L2+1, 0 
	MOVWF       FARG_ModbusSlave_setRegister_uintAddress+1 
	MOVF        ModbusSlave_aryBuffer+4, 0 
	MOVWF       FARG_ModbusSlave_setRegister_bytDataHi+0 
	MOVF        ModbusSlave_aryBuffer+5, 0 
	MOVWF       FARG_ModbusSlave_setRegister_bytDataLo+0 
	CALL        ModbusSlave_setRegister+0, 0
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket135
;ModbusSlave.c,651 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,652 :: 		}
L_decodePacket135:
;ModbusSlave.c,653 :: 		break;
	GOTO        L_decodePacket112
;ModbusSlave.c,654 :: 		case FORCE_MULTIPLE_COILS:
L_decodePacket136:
;ModbusSlave.c,656 :: 		uintItemCount > (aryBuffer[6] * 8) ) {
	MOVF        decodePacket_uintItemCount_L2+1, 0 
	SUBLW       7
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket244
	MOVF        decodePacket_uintItemCount_L2+0, 0 
	SUBLW       176
L__decodePacket244:
	BTFSS       STATUS+0, 0 
	GOTO        L__decodePacket189
	MOVLW       3
	MOVWF       R0 
	MOVF        ModbusSlave_aryBuffer+6, 0 
	MOVWF       R1 
	MOVLW       0
	MOVWF       R2 
	MOVF        R0, 0 
L__decodePacket245:
	BZ          L__decodePacket246
	RLCF        R1, 1 
	BCF         R1, 0 
	RLCF        R2, 1 
	ADDLW       255
	GOTO        L__decodePacket245
L__decodePacket246:
	MOVF        decodePacket_uintItemCount_L2+1, 0 
	SUBWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket247
	MOVF        decodePacket_uintItemCount_L2+0, 0 
	SUBWF       R1, 0 
L__decodePacket247:
	BTFSS       STATUS+0, 0 
	GOTO        L__decodePacket189
	GOTO        L_decodePacket139
L__decodePacket189:
;ModbusSlave.c,658 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,659 :: 		break;
	GOTO        L_decodePacket112
;ModbusSlave.c,660 :: 		}
L_decodePacket139:
;ModbusSlave.c,661 :: 		case PRESET_MULTIPLE_REGISTERS:
L_decodePacket140:
;ModbusSlave.c,663 :: 		uintItemCount > MAX_REGISTERS_IN_FC16) ) {
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       16
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket143
	MOVLW       0
	MOVWF       R0 
	MOVF        decodePacket_uintItemCount_L2+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket248
	MOVF        decodePacket_uintItemCount_L2+0, 0 
	SUBLW       123
L__decodePacket248:
	BTFSC       STATUS+0, 0 
	GOTO        L_decodePacket143
L__decodePacket188:
;ModbusSlave.c,665 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,666 :: 		} else {
	GOTO        L_decodePacket144
L_decodePacket143:
;ModbusSlave.c,667 :: 		bytBit = 1;
	MOVLW       1
	MOVWF       decodePacket_bytBit_L2+0 
;ModbusSlave.c,668 :: 		uintOffset = 0;
	CLRF        decodePacket_uintOffset_L2+0 
	CLRF        decodePacket_uintOffset_L2+1 
;ModbusSlave.c,669 :: 		uintAddr = uintSAddr;
	MOVF        decodePacket_uintSAddr_L2+0, 0 
	MOVWF       decodePacket_uintAddr_L2+0 
	MOVF        decodePacket_uintSAddr_L2+1, 0 
	MOVWF       decodePacket_uintAddr_L2+1 
;ModbusSlave.c,671 :: 		while( uintAddr <= uintEAddr ) {
L_decodePacket145:
	MOVF        decodePacket_uintAddr_L2+1, 0 
	SUBWF       decodePacket_uintEAddr_L2+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket249
	MOVF        decodePacket_uintAddr_L2+0, 0 
	SUBWF       decodePacket_uintEAddr_L2+0, 0 
L__decodePacket249:
	BTFSS       STATUS+0, 0 
	GOTO        L_decodePacket146
;ModbusSlave.c,672 :: 		if ( aryBuffer[1] == PRESET_MULTIPLE_REGISTERS ) {
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       16
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket147
;ModbusSlave.c,673 :: 		if ( setRegister(uintAddr,
	MOVF        decodePacket_uintAddr_L2+0, 0 
	MOVWF       FARG_ModbusSlave_setRegister_uintAddress+0 
	MOVF        decodePacket_uintAddr_L2+1, 0 
	MOVWF       FARG_ModbusSlave_setRegister_uintAddress+1 
;ModbusSlave.c,674 :: 		aryBuffer[7 + uintOffset],
	MOVLW       7
	ADDWF       decodePacket_uintOffset_L2+0, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      decodePacket_uintOffset_L2+1, 0 
	MOVWF       R1 
	MOVLW       ModbusSlave_aryBuffer+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_ModbusSlave_setRegister_bytDataHi+0 
;ModbusSlave.c,675 :: 		aryBuffer[8 + uintOffset]) == FALSE ) {
	MOVLW       8
	ADDWF       decodePacket_uintOffset_L2+0, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      decodePacket_uintOffset_L2+1, 0 
	MOVWF       R1 
	MOVLW       ModbusSlave_aryBuffer+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       FARG_ModbusSlave_setRegister_bytDataLo+0 
	CALL        ModbusSlave_setRegister+0, 0
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket148
;ModbusSlave.c,676 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,677 :: 		break;
	GOTO        L_decodePacket146
;ModbusSlave.c,678 :: 		}
L_decodePacket148:
;ModbusSlave.c,679 :: 		uintOffset += 2;
	MOVLW       2
	ADDWF       decodePacket_uintOffset_L2+0, 1 
	MOVLW       0
	ADDWFC      decodePacket_uintOffset_L2+1, 1 
;ModbusSlave.c,680 :: 		uintAddr++;
	INFSNZ      decodePacket_uintAddr_L2+0, 1 
	INCF        decodePacket_uintAddr_L2+1, 1 
;ModbusSlave.c,681 :: 		} else {
	GOTO        L_decodePacket149
L_decodePacket147:
;ModbusSlave.c,682 :: 		blnState = FALSE;
	CLRF        decodePacket_blnState_L2+0 
;ModbusSlave.c,683 :: 		if ( (aryBuffer[7 + uintOffset] & bytBit) > 0 ) {
	MOVLW       7
	ADDWF       decodePacket_uintOffset_L2+0, 0 
	MOVWF       R0 
	MOVLW       0
	ADDWFC      decodePacket_uintOffset_L2+1, 0 
	MOVWF       R1 
	MOVLW       ModbusSlave_aryBuffer+0
	ADDWF       R0, 0 
	MOVWF       FSR0 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+0)
	ADDWFC      R1, 0 
	MOVWF       FSR0H 
	MOVF        decodePacket_bytBit_L2+0, 0 
	ANDWF       POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        R1, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_decodePacket150
;ModbusSlave.c,684 :: 		blnState = TRUE;
	MOVLW       1
	MOVWF       decodePacket_blnState_L2+0 
;ModbusSlave.c,685 :: 		}
L_decodePacket150:
;ModbusSlave.c,686 :: 		if ( coilState(uintAddr, blnState) == FALSE ) {
	MOVF        decodePacket_uintAddr_L2+0, 0 
	MOVWF       FARG_ModbusSlave_coilState_uintAddress+0 
	MOVF        decodePacket_uintAddr_L2+1, 0 
	MOVWF       FARG_ModbusSlave_coilState_uintAddress+1 
	MOVF        decodePacket_blnState_L2+0, 0 
	MOVWF       FARG_ModbusSlave_coilState_blnState+0 
	CALL        ModbusSlave_coilState+0, 0
	MOVF        R0, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket151
;ModbusSlave.c,687 :: 		exceptionCode = ILLEGAL_DATA_ADDRESS;
	MOVLW       2
	MOVWF       ModbusSlave_exceptionCode+0 
;ModbusSlave.c,688 :: 		break;
	GOTO        L_decodePacket146
;ModbusSlave.c,689 :: 		}
L_decodePacket151:
;ModbusSlave.c,690 :: 		bytBit <<= 1;
	MOVF        decodePacket_bytBit_L2+0, 0 
	MOVWF       R1 
	RLCF        R1, 1 
	BCF         R1, 0 
	MOVF        R1, 0 
	MOVWF       decodePacket_bytBit_L2+0 
;ModbusSlave.c,691 :: 		if ( bytBit == 0 ) {
	MOVF        R1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L_decodePacket152
;ModbusSlave.c,692 :: 		bytBit = 1;
	MOVLW       1
	MOVWF       decodePacket_bytBit_L2+0 
;ModbusSlave.c,693 :: 		uintOffset++;
	INFSNZ      decodePacket_uintOffset_L2+0, 1 
	INCF        decodePacket_uintOffset_L2+1, 1 
;ModbusSlave.c,694 :: 		}
L_decodePacket152:
;ModbusSlave.c,695 :: 		uintAddr++;
	INFSNZ      decodePacket_uintAddr_L2+0, 1 
	INCF        decodePacket_uintAddr_L2+1, 1 
;ModbusSlave.c,696 :: 		}
L_decodePacket149:
;ModbusSlave.c,697 :: 		}
	GOTO        L_decodePacket145
L_decodePacket146:
;ModbusSlave.c,698 :: 		}
L_decodePacket144:
;ModbusSlave.c,699 :: 		break;
	GOTO        L_decodePacket112
;ModbusSlave.c,700 :: 		}
L_decodePacket111:
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket113
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       2
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket114
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       3
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket119
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       4
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket120
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       5
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket125
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       6
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket134
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       15
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket136
	MOVF        ModbusSlave_aryBuffer+1, 0 
	XORLW       16
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket140
L_decodePacket112:
;ModbusSlave.c,701 :: 		if( exceptionCode != NO_EXCEPTION ) {
	MOVF        ModbusSlave_exceptionCode+0, 0 
	XORLW       0
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket153
;ModbusSlave.c,702 :: 		aryBuffer[1] |= EXCEPTION_FLAG;
	BSF         ModbusSlave_aryBuffer+1, 7 
;ModbusSlave.c,703 :: 		aryBuffer[2] = (byte)exceptionCode;
	MOVF        ModbusSlave_exceptionCode+0, 0 
	MOVWF       ModbusSlave_aryBuffer+2 
;ModbusSlave.c,704 :: 		exceptionCode = NO_EXCEPTION;
	CLRF        ModbusSlave_exceptionCode+0 
;ModbusSlave.c,705 :: 		uintLength = 3;
	MOVLW       3
	MOVWF       decodePacket_uintLength_L2+0 
	MOVLW       0
	MOVWF       decodePacket_uintLength_L2+1 
;ModbusSlave.c,706 :: 		}
L_decodePacket153:
;ModbusSlave.c,707 :: 		if ( uintLength > 0 ) {
	MOVLW       0
	MOVWF       R0 
	MOVF        decodePacket_uintLength_L2+1, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket250
	MOVF        decodePacket_uintLength_L2+0, 0 
	SUBLW       0
L__decodePacket250:
	BTFSC       STATUS+0, 0 
	GOTO        L_decodePacket154
;ModbusSlave.c,709 :: 		if ( pWriteBlock != NULL && pWriteBlock->pCallback != NULL ) {
	MOVLW       0
	XORWF       ModbusSlave_pWriteBlock+1, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket251
	MOVLW       0
	XORWF       ModbusSlave_pWriteBlock+0, 0 
L__decodePacket251:
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket157
	MOVLW       7
	ADDWF       ModbusSlave_pWriteBlock+0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      ModbusSlave_pWriteBlock+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R2 
	MOVF        POSTINC0+0, 0 
	MOVWF       R3 
	MOVF        POSTINC0+0, 0 
	MOVWF       R4 
	MOVLW       0
	MOVWF       R0 
	XORWF       R4, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket252
	MOVF        R0, 0 
	XORWF       R3, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket252
	MOVF        R0, 0 
	XORWF       R2, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__decodePacket252
	MOVF        R1, 0 
	XORLW       0
L__decodePacket252:
	BTFSC       STATUS+0, 2 
	GOTO        L_decodePacket157
L__decodePacket187:
;ModbusSlave.c,710 :: 		(*pWriteBlock->pCallback)(pWriteBlock);
	MOVLW       7
	ADDWF       ModbusSlave_pWriteBlock+0, 0 
	MOVWF       FSR0 
	MOVLW       0
	ADDWFC      ModbusSlave_pWriteBlock+1, 0 
	MOVWF       FSR0H 
	MOVF        POSTINC0+0, 0 
	MOVWF       R0 
	MOVF        POSTINC0+0, 0 
	MOVWF       R1 
	MOVF        POSTINC0+0, 0 
	MOVWF       R2 
	MOVF        POSTINC0+0, 0 
	MOVWF       R3 
	MOVF        R2, 0 
	MOVWF       FSR1 
	MOVF        R3, 0 
	MOVWF       FSR1H 
	MOVF        ModbusSlave_pWriteBlock+0, 0 
	MOVWF       POSTINC1+0 
	MOVF        ModbusSlave_pWriteBlock+1, 0 
	MOVWF       POSTINC1+0 
	CALL        _____DoIFC+0, 0
;ModbusSlave.c,711 :: 		}
L_decodePacket157:
;ModbusSlave.c,713 :: 		uintCRC = calcCRC(uintLength);
	MOVF        decodePacket_uintLength_L2+0, 0 
	MOVWF       FARG_ModbusSlave_calcCRC_uintLength+0 
	MOVF        decodePacket_uintLength_L2+1, 0 
	MOVWF       FARG_ModbusSlave_calcCRC_uintLength+1 
	CALL        ModbusSlave_calcCRC+0, 0
	MOVF        R0, 0 
	MOVWF       decodePacket_uintCRC_L1+0 
	MOVF        R1, 0 
	MOVWF       decodePacket_uintCRC_L1+1 
;ModbusSlave.c,714 :: 		aryBuffer[uintLength++] = Lo(uintCRC);
	MOVLW       ModbusSlave_aryBuffer+0
	ADDWF       decodePacket_uintLength_L2+0, 0 
	MOVWF       FSR1 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+0)
	ADDWFC      decodePacket_uintLength_L2+1, 0 
	MOVWF       FSR1H 
	MOVF        decodePacket_uintCRC_L1+0, 0 
	MOVWF       POSTINC1+0 
	INFSNZ      decodePacket_uintLength_L2+0, 1 
	INCF        decodePacket_uintLength_L2+1, 1 
;ModbusSlave.c,715 :: 		aryBuffer[uintLength++] = Hi(uintCRC);
	MOVLW       ModbusSlave_aryBuffer+0
	ADDWF       decodePacket_uintLength_L2+0, 0 
	MOVWF       FSR1 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+0)
	ADDWFC      decodePacket_uintLength_L2+1, 0 
	MOVWF       FSR1H 
	MOVF        decodePacket_uintCRC_L1+1, 0 
	MOVWF       POSTINC1+0 
	INFSNZ      decodePacket_uintLength_L2+0, 1 
	INCF        decodePacket_uintLength_L2+1, 1 
;ModbusSlave.c,717 :: 		CREN_bit = 0;
	BCF         CREN_bit+0, 4 
;ModbusSlave.c,718 :: 		RCIE_bit = 0;
	BCF         RCIE_bit+0, 5 
;ModbusSlave.c,720 :: 		TXEN_bit = 1;
	BSF         TXEN_bit+0, 5 
;ModbusSlave.c,721 :: 		Tx_dir = 1;
	BSF         LATE+0, 0 
;ModbusSlave.c,723 :: 		bytRxphase = 128;
	MOVLW       128
	MOVWF       ModbusSlave_bytRxphase+0 
;ModbusSlave.c,725 :: 		TXREG = bytSlaveAddress;
	MOVF        ModbusSlave_bytSlaveAddress+0, 0 
	MOVWF       TXREG+0 
;ModbusSlave.c,727 :: 		aryBuffer[0] = uintLength;
	MOVF        decodePacket_uintLength_L2+0, 0 
	MOVWF       ModbusSlave_aryBuffer+0 
;ModbusSlave.c,728 :: 		bytIndex = 2;
	MOVLW       2
	MOVWF       ModbusSlave_bytIndex+0 
;ModbusSlave.c,730 :: 		while( !TXIF_bit ){}
L_decodePacket158:
	BTFSC       TXIF_bit+0, 4 
	GOTO        L_decodePacket159
	GOTO        L_decodePacket158
L_decodePacket159:
;ModbusSlave.c,731 :: 		TXREG = aryBuffer[1];
	MOVF        ModbusSlave_aryBuffer+1, 0 
	MOVWF       TXREG+0 
;ModbusSlave.c,733 :: 		TXIE_bit = 1;
	BSF         TXIE_bit+0, 4 
;ModbusSlave.c,734 :: 		return;
	GOTO        L_end_decodePacket
;ModbusSlave.c,735 :: 		}
L_decodePacket154:
;ModbusSlave.c,736 :: 		}
L_decodePacket110:
;ModbusSlave.c,737 :: 		}
L_decodePacket89:
;ModbusSlave.c,739 :: 		bytIndex = 0;
	CLRF        ModbusSlave_bytIndex+0 
;ModbusSlave.c,740 :: 		bytRxphase = 1;
	MOVLW       1
	MOVWF       ModbusSlave_bytRxphase+0 
;ModbusSlave.c,741 :: 		}
L_end_decodePacket:
	RETURN      0
; end of _decodePacket

_modbusSlave:

;ModbusSlave.c,754 :: 		int modbusSlave(baudRate eBaud, const byte bytAddress, const byte bytStopBits) {
;ModbusSlave.c,758 :: 		if ( bytAddress < 1 || bytAddress > 247 ) {
	MOVLW       1
	SUBWF       FARG_modbusSlave_bytAddress+0, 0 
	BTFSS       STATUS+0, 0 
	GOTO        L__modbusSlave197
	MOVF        FARG_modbusSlave_bytAddress+0, 0 
	SUBLW       247
	BTFSS       STATUS+0, 0 
	GOTO        L__modbusSlave197
	GOTO        L_modbusSlave162
L__modbusSlave197:
;ModbusSlave.c,759 :: 		return -1;
	MOVLW       255
	MOVWF       R0 
	MOVLW       255
	MOVWF       R1 
	GOTO        L_end_modbusSlave
;ModbusSlave.c,760 :: 		}
L_modbusSlave162:
;ModbusSlave.c,762 :: 		memset(aryBuffer, 0, sizeof(aryBuffer));
	MOVLW       ModbusSlave_aryBuffer+0
	MOVWF       FARG_memset_p1+0 
	MOVLW       hi_addr(ModbusSlave_aryBuffer+0)
	MOVWF       FARG_memset_p1+1 
	CLRF        FARG_memset_character+0 
	MOVLW       0
	MOVWF       FARG_memset_n+0 
	MOVLW       1
	MOVWF       FARG_memset_n+1 
	CALL        _memset+0, 0
;ModbusSlave.c,764 :: 		bytSlaveAddress = bytAddress;
	MOVF        FARG_modbusSlave_bytAddress+0, 0 
	MOVWF       ModbusSlave_bytSlaveAddress+0 
;ModbusSlave.c,766 :: 		uintRxGap = 0;
	CLRF        ModbusSlave_uintRxGap+0 
	CLRF        ModbusSlave_uintRxGap+1 
;ModbusSlave.c,768 :: 		exceptionCode = NO_EXCEPTION;
	CLRF        ModbusSlave_exceptionCode+0 
;ModbusSlave.c,770 :: 		switch( eBaud ) {
	GOTO        L_modbusSlave163
;ModbusSlave.c,771 :: 		case BAUD_1200:
L_modbusSlave165:
;ModbusSlave.c,772 :: 		UART1_Init(BAUD_1200 * 100);
	BSF         BAUDCON+0, 3, 0
	MOVLW       26
	MOVWF       SPBRGH+0 
	MOVLW       10
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;ModbusSlave.c,773 :: 		lngTimeoutPreset = GAP_SETPT_1200;
	MOVLW       234
	MOVWF       modbusSlave_lngTimeoutPreset_L0+0 
	MOVLW       60
	MOVWF       modbusSlave_lngTimeoutPreset_L0+1 
	MOVLW       2
	MOVWF       modbusSlave_lngTimeoutPreset_L0+2 
	MOVLW       0
	MOVWF       modbusSlave_lngTimeoutPreset_L0+3 
;ModbusSlave.c,774 :: 		break;
	GOTO        L_modbusSlave164
;ModbusSlave.c,775 :: 		case BAUD_2400:
L_modbusSlave166:
;ModbusSlave.c,776 :: 		UART1_Init(BAUD_2400 * 100);
	BSF         BAUDCON+0, 3, 0
	MOVLW       13
	MOVWF       SPBRGH+0 
	MOVLW       4
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;ModbusSlave.c,777 :: 		lngTimeoutPreset = GAP_SETPT_2400;
	MOVLW       117
	MOVWF       modbusSlave_lngTimeoutPreset_L0+0 
	MOVLW       30
	MOVWF       modbusSlave_lngTimeoutPreset_L0+1 
	MOVLW       1
	MOVWF       modbusSlave_lngTimeoutPreset_L0+2 
	MOVLW       0
	MOVWF       modbusSlave_lngTimeoutPreset_L0+3 
;ModbusSlave.c,778 :: 		break;
	GOTO        L_modbusSlave164
;ModbusSlave.c,779 :: 		case BAUD_4800:
L_modbusSlave167:
;ModbusSlave.c,780 :: 		UART1_Init(BAUD_4800 * 100);
	BSF         BAUDCON+0, 3, 0
	MOVLW       6
	MOVWF       SPBRGH+0 
	MOVLW       130
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;ModbusSlave.c,781 :: 		lngTimeoutPreset = GAP_SETPT_4800;
	MOVLW       58
	MOVWF       modbusSlave_lngTimeoutPreset_L0+0 
	MOVLW       143
	MOVWF       modbusSlave_lngTimeoutPreset_L0+1 
	MOVLW       0
	MOVWF       modbusSlave_lngTimeoutPreset_L0+2 
	MOVLW       0
	MOVWF       modbusSlave_lngTimeoutPreset_L0+3 
;ModbusSlave.c,782 :: 		break;
	GOTO        L_modbusSlave164
;ModbusSlave.c,783 :: 		case BAUD_9600:
L_modbusSlave168:
;ModbusSlave.c,784 :: 		UART1_Init(BAUD_9600 * 100);
	BSF         BAUDCON+0, 3, 0
	MOVLW       3
	MOVWF       SPBRGH+0 
	MOVLW       64
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;ModbusSlave.c,785 :: 		lngTimeoutPreset = GAP_SETPT_9600;
	MOVLW       157
	MOVWF       modbusSlave_lngTimeoutPreset_L0+0 
	MOVLW       71
	MOVWF       modbusSlave_lngTimeoutPreset_L0+1 
	MOVLW       0
	MOVWF       modbusSlave_lngTimeoutPreset_L0+2 
	MOVLW       0
	MOVWF       modbusSlave_lngTimeoutPreset_L0+3 
;ModbusSlave.c,786 :: 		break;
	GOTO        L_modbusSlave164
;ModbusSlave.c,787 :: 		case BAUD_19200:
L_modbusSlave169:
;ModbusSlave.c,788 :: 		UART1_Init(BAUD_19200 * 100);
	BSF         BAUDCON+0, 3, 0
	MOVLW       1
	MOVWF       SPBRGH+0 
	MOVLW       160
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;ModbusSlave.c,789 :: 		lngTimeoutPreset = GAP_SETPT_19200;
	MOVLW       206
	MOVWF       modbusSlave_lngTimeoutPreset_L0+0 
	MOVLW       35
	MOVWF       modbusSlave_lngTimeoutPreset_L0+1 
	MOVLW       0
	MOVWF       modbusSlave_lngTimeoutPreset_L0+2 
	MOVLW       0
	MOVWF       modbusSlave_lngTimeoutPreset_L0+3 
;ModbusSlave.c,790 :: 		break;
	GOTO        L_modbusSlave164
;ModbusSlave.c,791 :: 		case BAUD_38400:
L_modbusSlave170:
;ModbusSlave.c,792 :: 		UART1_Init(BAUD_38400 * 100);
	BSF         BAUDCON+0, 3, 0
	CLRF        SPBRGH+0 
	MOVLW       207
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;ModbusSlave.c,793 :: 		lngTimeoutPreset = GAP_SETPT_38400;
	MOVLW       231
	MOVWF       modbusSlave_lngTimeoutPreset_L0+0 
	MOVLW       17
	MOVWF       modbusSlave_lngTimeoutPreset_L0+1 
	MOVLW       0
	MOVWF       modbusSlave_lngTimeoutPreset_L0+2 
	MOVLW       0
	MOVWF       modbusSlave_lngTimeoutPreset_L0+3 
;ModbusSlave.c,794 :: 		break;
	GOTO        L_modbusSlave164
;ModbusSlave.c,795 :: 		case BAUD_57600:
L_modbusSlave171:
;ModbusSlave.c,796 :: 		UART1_Init(BAUD_57600 * 100);
	BSF         BAUDCON+0, 3, 0
	CLRF        SPBRGH+0 
	MOVLW       138
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;ModbusSlave.c,797 :: 		lngTimeoutPreset = GAP_SETPT_57600;
	MOVLW       239
	MOVWF       modbusSlave_lngTimeoutPreset_L0+0 
	MOVLW       11
	MOVWF       modbusSlave_lngTimeoutPreset_L0+1 
	MOVLW       0
	MOVWF       modbusSlave_lngTimeoutPreset_L0+2 
	MOVLW       0
	MOVWF       modbusSlave_lngTimeoutPreset_L0+3 
;ModbusSlave.c,798 :: 		break;
	GOTO        L_modbusSlave164
;ModbusSlave.c,799 :: 		case BAUD_115200:
L_modbusSlave172:
;ModbusSlave.c,800 :: 		UART1_Init(BAUD_115200 * 100);
	BSF         BAUDCON+0, 3, 0
	CLRF        SPBRGH+0 
	MOVLW       68
	MOVWF       SPBRG+0 
	BSF         TXSTA+0, 2, 0
	CALL        _UART1_Init+0, 0
;ModbusSlave.c,801 :: 		lngTimeoutPreset = GAP_SETPT_115200;
	MOVLW       247
	MOVWF       modbusSlave_lngTimeoutPreset_L0+0 
	MOVLW       5
	MOVWF       modbusSlave_lngTimeoutPreset_L0+1 
	MOVLW       0
	MOVWF       modbusSlave_lngTimeoutPreset_L0+2 
	MOVLW       0
	MOVWF       modbusSlave_lngTimeoutPreset_L0+3 
;ModbusSlave.c,802 :: 		break;
	GOTO        L_modbusSlave164
;ModbusSlave.c,803 :: 		default:
L_modbusSlave173:
;ModbusSlave.c,804 :: 		return -1;
	MOVLW       255
	MOVWF       R0 
	MOVLW       255
	MOVWF       R1 
	GOTO        L_end_modbusSlave
;ModbusSlave.c,805 :: 		}
L_modbusSlave163:
	MOVF        FARG_modbusSlave_eBaud+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__modbusSlave254
	MOVLW       12
	XORWF       FARG_modbusSlave_eBaud+0, 0 
L__modbusSlave254:
	BTFSC       STATUS+0, 2 
	GOTO        L_modbusSlave165
	MOVF        FARG_modbusSlave_eBaud+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__modbusSlave255
	MOVLW       24
	XORWF       FARG_modbusSlave_eBaud+0, 0 
L__modbusSlave255:
	BTFSC       STATUS+0, 2 
	GOTO        L_modbusSlave166
	MOVF        FARG_modbusSlave_eBaud+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__modbusSlave256
	MOVLW       48
	XORWF       FARG_modbusSlave_eBaud+0, 0 
L__modbusSlave256:
	BTFSC       STATUS+0, 2 
	GOTO        L_modbusSlave167
	MOVF        FARG_modbusSlave_eBaud+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__modbusSlave257
	MOVLW       96
	XORWF       FARG_modbusSlave_eBaud+0, 0 
L__modbusSlave257:
	BTFSC       STATUS+0, 2 
	GOTO        L_modbusSlave168
	MOVF        FARG_modbusSlave_eBaud+1, 0 
	XORLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__modbusSlave258
	MOVLW       192
	XORWF       FARG_modbusSlave_eBaud+0, 0 
L__modbusSlave258:
	BTFSC       STATUS+0, 2 
	GOTO        L_modbusSlave169
	MOVF        FARG_modbusSlave_eBaud+1, 0 
	XORLW       1
	BTFSS       STATUS+0, 2 
	GOTO        L__modbusSlave259
	MOVLW       128
	XORWF       FARG_modbusSlave_eBaud+0, 0 
L__modbusSlave259:
	BTFSC       STATUS+0, 2 
	GOTO        L_modbusSlave170
	MOVF        FARG_modbusSlave_eBaud+1, 0 
	XORLW       2
	BTFSS       STATUS+0, 2 
	GOTO        L__modbusSlave260
	MOVLW       64
	XORWF       FARG_modbusSlave_eBaud+0, 0 
L__modbusSlave260:
	BTFSC       STATUS+0, 2 
	GOTO        L_modbusSlave171
	MOVF        FARG_modbusSlave_eBaud+1, 0 
	XORLW       4
	BTFSS       STATUS+0, 2 
	GOTO        L__modbusSlave261
	MOVLW       128
	XORWF       FARG_modbusSlave_eBaud+0, 0 
L__modbusSlave261:
	BTFSC       STATUS+0, 2 
	GOTO        L_modbusSlave172
	GOTO        L_modbusSlave173
L_modbusSlave164:
;ModbusSlave.c,807 :: 		Delay_ms(100);
	MOVLW       5
	MOVWF       R11, 0
	MOVLW       15
	MOVWF       R12, 0
	MOVLW       241
	MOVWF       R13, 0
L_modbusSlave174:
	DECFSZ      R13, 1, 1
	BRA         L_modbusSlave174
	DECFSZ      R12, 1, 1
	BRA         L_modbusSlave174
	DECFSZ      R11, 1, 1
	BRA         L_modbusSlave174
;ModbusSlave.c,811 :: 		T0CON.TMR0ON = 0;// Timer0 On/Off Control bit 1=Enables / 0=Stops
	BCF         T0CON+0, 7 
;ModbusSlave.c,812 :: 		T0CON.T08BIT = 0;// Timer0 8-bit/16-bit Control bit: 1=8-bit/ 0=16-bit
	BCF         T0CON+0, 6 
;ModbusSlave.c,813 :: 		T0CON.T0CS   = 0;// TMR0 Clock Source Select bit: 0=Internal
	BCF         T0CON+0, 5 
;ModbusSlave.c,814 :: 		T0CON.T0SE   = 0;// TMR0 Source Edge Select bit: 0=low/high
	BCF         T0CON+0, 4 
;ModbusSlave.c,815 :: 		T0CON.PSA    = 1;// Prescaler Assignment bit: 1=NOT assigned/bypassed
	BSF         T0CON+0, 3 
;ModbusSlave.c,816 :: 		T0CON.T0PS2  = 0;// bits 2-0  PS2:PS0: Prescaler Select bits
	BCF         T0CON+0, 2 
;ModbusSlave.c,817 :: 		T0CON.T0PS1  = 0;
	BCF         T0CON+0, 1 
;ModbusSlave.c,818 :: 		T0CON.T0PS0  = 0;
	BCF         T0CON+0, 0 
;ModbusSlave.c,820 :: 		bytTemp = 0;
	CLRF        modbusSlave_bytTemp_L0+0 
;ModbusSlave.c,821 :: 		while( lngTimeoutPreset > 29126 ) {
L_modbusSlave175:
	MOVLW       128
	MOVWF       R0 
	MOVLW       128
	XORWF       modbusSlave_lngTimeoutPreset_L0+3, 0 
	SUBWF       R0, 0 
	BTFSS       STATUS+0, 2 
	GOTO        L__modbusSlave262
	MOVF        modbusSlave_lngTimeoutPreset_L0+2, 0 
	SUBLW       0
	BTFSS       STATUS+0, 2 
	GOTO        L__modbusSlave262
	MOVF        modbusSlave_lngTimeoutPreset_L0+1, 0 
	SUBLW       113
	BTFSS       STATUS+0, 2 
	GOTO        L__modbusSlave262
	MOVF        modbusSlave_lngTimeoutPreset_L0+0, 0 
	SUBLW       198
L__modbusSlave262:
	BTFSC       STATUS+0, 0 
	GOTO        L_modbusSlave176
;ModbusSlave.c,822 :: 		lngTimeoutPreset >>= 1;
	RRCF        modbusSlave_lngTimeoutPreset_L0+3, 1 
	RRCF        modbusSlave_lngTimeoutPreset_L0+2, 1 
	RRCF        modbusSlave_lngTimeoutPreset_L0+1, 1 
	RRCF        modbusSlave_lngTimeoutPreset_L0+0, 1 
	BCF         modbusSlave_lngTimeoutPreset_L0+3, 7 
	BTFSC       modbusSlave_lngTimeoutPreset_L0+3, 6 
	BSF         modbusSlave_lngTimeoutPreset_L0+3, 7 
;ModbusSlave.c,823 :: 		bytTemp++;
	INCF        modbusSlave_bytTemp_L0+0, 1 
;ModbusSlave.c,824 :: 		}
	GOTO        L_modbusSlave175
L_modbusSlave176:
;ModbusSlave.c,825 :: 		if ( bytTemp > 0 && bytTemp <= 8 ) {
	MOVF        modbusSlave_bytTemp_L0+0, 0 
	SUBLW       0
	BTFSC       STATUS+0, 0 
	GOTO        L_modbusSlave179
	MOVF        modbusSlave_bytTemp_L0+0, 0 
	SUBLW       8
	BTFSS       STATUS+0, 0 
	GOTO        L_modbusSlave179
L__modbusSlave196:
;ModbusSlave.c,826 :: 		T0CON.PSA = 0;   // Prescaler assigned
	BCF         T0CON+0, 3 
;ModbusSlave.c,827 :: 		T0CON = T0CON | (--bytTemp & 0x07);
	DECF        modbusSlave_bytTemp_L0+0, 1 
	MOVLW       7
	ANDWF       modbusSlave_bytTemp_L0+0, 0 
	MOVWF       R0 
	MOVF        R0, 0 
	IORWF       T0CON+0, 1 
;ModbusSlave.c,828 :: 		}
L_modbusSlave179:
;ModbusSlave.c,829 :: 		uintRxGapSetPt1 = (uint)-(lngTimeoutPreset >> 1);   // 1 char
	MOVF        modbusSlave_lngTimeoutPreset_L0+0, 0 
	MOVWF       R0 
	MOVF        modbusSlave_lngTimeoutPreset_L0+1, 0 
	MOVWF       R1 
	MOVF        modbusSlave_lngTimeoutPreset_L0+2, 0 
	MOVWF       R2 
	MOVF        modbusSlave_lngTimeoutPreset_L0+3, 0 
	MOVWF       R3 
	RRCF        R3, 1 
	RRCF        R2, 1 
	RRCF        R1, 1 
	RRCF        R0, 1 
	BCF         R3, 7 
	BTFSC       R3, 6 
	BSF         R3, 7 
	MOVF        R0, 0 
	SUBLW       0
	MOVWF       ModbusSlave_uintRxGapSetPt1+0 
	MOVF        R1, 0 
	MOVWF       ModbusSlave_uintRxGapSetPt1+1 
	MOVLW       0
	SUBFWB      ModbusSlave_uintRxGapSetPt1+1, 1 
;ModbusSlave.c,830 :: 		uintRxGapSetPt2 = (uint)-lngTimeoutPreset;          // 2 chars
	MOVF        modbusSlave_lngTimeoutPreset_L0+0, 0 
	SUBLW       0
	MOVWF       ModbusSlave_uintRxGapSetPt2+0 
	MOVF        modbusSlave_lngTimeoutPreset_L0+1, 0 
	MOVWF       ModbusSlave_uintRxGapSetPt2+1 
	MOVLW       0
	SUBFWB      ModbusSlave_uintRxGapSetPt2+1, 1 
;ModbusSlave.c,831 :: 		uintRxGapSetPt3 = (uint)-(lngTimeoutPreset*5 >> 2); // 2.5 chars
	MOVF        modbusSlave_lngTimeoutPreset_L0+0, 0 
	MOVWF       R0 
	MOVF        modbusSlave_lngTimeoutPreset_L0+1, 0 
	MOVWF       R1 
	MOVF        modbusSlave_lngTimeoutPreset_L0+2, 0 
	MOVWF       R2 
	MOVF        modbusSlave_lngTimeoutPreset_L0+3, 0 
	MOVWF       R3 
	MOVLW       5
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVWF       R6 
	MOVWF       R7 
	CALL        _Mul_32x32_U+0, 0
	MOVF        R0, 0 
	MOVWF       R4 
	MOVF        R1, 0 
	MOVWF       R5 
	MOVF        R2, 0 
	MOVWF       R6 
	MOVF        R3, 0 
	MOVWF       R7 
	RRCF        R7, 1 
	RRCF        R6, 1 
	RRCF        R5, 1 
	RRCF        R4, 1 
	BCF         R7, 7 
	BTFSC       R7, 6 
	BSF         R7, 7 
	RRCF        R7, 1 
	RRCF        R6, 1 
	RRCF        R5, 1 
	RRCF        R4, 1 
	BCF         R7, 7 
	BTFSC       R7, 6 
	BSF         R7, 7 
	MOVF        R4, 0 
	SUBLW       0
	MOVWF       ModbusSlave_uintRxGapSetPt3+0 
	MOVF        R5, 0 
	MOVWF       ModbusSlave_uintRxGapSetPt3+1 
	MOVLW       0
	SUBFWB      ModbusSlave_uintRxGapSetPt3+1, 1 
;ModbusSlave.c,832 :: 		uintRxGapSetPt  = (uint)-(lngTimeoutPreset*9 >> 2); // 4.5 chars
	MOVF        modbusSlave_lngTimeoutPreset_L0+0, 0 
	MOVWF       R0 
	MOVF        modbusSlave_lngTimeoutPreset_L0+1, 0 
	MOVWF       R1 
	MOVF        modbusSlave_lngTimeoutPreset_L0+2, 0 
	MOVWF       R2 
	MOVF        modbusSlave_lngTimeoutPreset_L0+3, 0 
	MOVWF       R3 
	MOVLW       9
	MOVWF       R4 
	MOVLW       0
	MOVWF       R5 
	MOVWF       R6 
	MOVWF       R7 
	CALL        _Mul_32x32_U+0, 0
	MOVF        R0, 0 
	MOVWF       R4 
	MOVF        R1, 0 
	MOVWF       R5 
	MOVF        R2, 0 
	MOVWF       R6 
	MOVF        R3, 0 
	MOVWF       R7 
	RRCF        R7, 1 
	RRCF        R6, 1 
	RRCF        R5, 1 
	RRCF        R4, 1 
	BCF         R7, 7 
	BTFSC       R7, 6 
	BSF         R7, 7 
	RRCF        R7, 1 
	RRCF        R6, 1 
	RRCF        R5, 1 
	RRCF        R4, 1 
	BCF         R7, 7 
	BTFSC       R7, 6 
	BSF         R7, 7 
	MOVF        R4, 0 
	SUBLW       0
	MOVWF       ModbusSlave_uintRxGapSetPt+0 
	MOVF        R5, 0 
	MOVWF       ModbusSlave_uintRxGapSetPt+1 
	MOVLW       0
	SUBFWB      ModbusSlave_uintRxGapSetPt+1, 1 
;ModbusSlave.c,834 :: 		if ( bytStopBits != 1 ) {
	MOVF        FARG_modbusSlave_bytStopBits+0, 0 
	XORLW       1
	BTFSC       STATUS+0, 2 
	GOTO        L_modbusSlave180
;ModbusSlave.c,835 :: 		TX9_bit  = 1;
	BSF         TX9_bit+0, 6 
;ModbusSlave.c,836 :: 		TX9D_bit = 1;
	BSF         TX9D_bit+0, 0 
;ModbusSlave.c,837 :: 		}
L_modbusSlave180:
;ModbusSlave.c,840 :: 		restartRx();
	CALL        ModbusSlave_restartRx+0, 0
;ModbusSlave.c,841 :: 		TMR0IE_bit = 1;
	BSF         TMR0IE_bit+0, 5 
;ModbusSlave.c,843 :: 		PEIE_bit   = 1;
	BSF         PEIE_bit+0, 6 
;ModbusSlave.c,845 :: 		GIE_bit    = 1;
	BSF         GIE_bit+0, 7 
;ModbusSlave.c,846 :: 		}
L_end_modbusSlave:
	RETURN      0
; end of _modbusSlave
